<%--
 ** Component: cases
 **
 ** WEB interface for batch approving a group of reports.
 **
 **  @param cGr               Study Instance UIDs (used only initially)
 **  @param cBack             URL to go back after finishing
 **  @param cOp               Operation Mode: approve, unapprove, finish, prev, next
 **  @param cCurrentID        identifies the current reportpart
 **  @param cConfirm          Approve operation is confirmed
 **	 @param cContext					context containing current status of the Batch Approve operation
 **
 ** $Author$
 ** $Date$
 **
 *
 *  RCS File Name    : $RCSfile: batchReportSign.jsp,v $
 *  RCS Revsession     : $Revsession: 1.41 $
 *  Locked by        : $Locker:  $
 *  Symbolic name    : $Name:  $
 *  State            : $State: Exp $
--%><%@page import="com.erad.pacs.modules.gwt.session.BrowserInfo"%>
<%@page import="com.erad.pacs.modules.gwt.descriptors.akac.LockDescriptor"%>
<%@page import="com.erad.pacs.modules.gwt.session.right.PacsRight"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="com.erad.pacs.services.usermanager.client.RequestConsts"%>
<%@page import="imagemed.http.rmi.StudyLockerExecutable.LockResult"%>
<%@page import="com.erad.pacs.common.interfaces.AkacFacade"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="imagemed.types.flag.IMTypeur"%>
<%@
	page errorPage ="../main/exceptionHandler.jsp"
%><%@
  page import="imagemed.imsession.*,java.util.*,imagemed.exception.*,imagemed.util.*,imagemed.jsputil.*,imagemed.dotcom.DotcomConfig,java.sql.*,imagemed.types.*,imagemed.types.enumeration.*,java.text.Format"
%>
<%@page import="com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*,com.erad.pacs.app.broker.table.internals.action.*,com.erad.pacs.app.broker.table.internals.lists.*,com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl" %>
<%
	//final int lockMode = 0;
	// 0 -> lock every preliminary studies in advance
	// 1 -> lock/unlock selected studies on selection
	// 2 -> lock selected studies before confirmation
	
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );

	response.setHeader("Cache-Control","no-cache"); //HTTP 1.1
	response.setHeader("Pragma","no-cache"); //HTTP 1.0
	response.setDateHeader ("Expires", -1); //prevents caching at the proxy server
	
	Context context = new Context( sess, request );
	
	if ( userManager.isSessionRemote( sess.getSessionId() ) ) { // redirect back to the referring host.
		String host = request.getParameter( "ReferrerHost" );
		if (host == null) {
			host = RedirectToolbox.getURL( DotcomConfig.getConfig().getServerNameTowards( userManager.getDeviceForSession( sess.getSessionId() ) ), sess.getClientAddress().getHostAddress(), null );
		}
		String redirURL = host + "/cases/batchReportSign.jsp?" + request.getQueryString();
		if (request.getParameter( RequestConsts.QUERYSTRING_PARENT_SESSION_ID_NAME ) == null ) {
			redirURL += "&"+RequestConsts.QUERYSTRING_PARENT_SESSION_ID_NAME+"="+sess.getSessionId();
		}
		response.sendRedirect( redirURL );
		return;
	}
	BatchApproveToolbox.abortUnlocking( sess.getSessionId() );
	
%>
<HTML>
<HEAD>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<%
	if (!sess.getRights(  ).hasRight( PacsRight.Report )) {
		throw new IMException( LocalizedMessage.getSimpleMessage( "NO_PERMISSION_TO_THIS_PAGE" ) + "." );
  	}

  	TabToolbox.writeIMpopup(out);
  	imagemed.http.tabs.TabBean.writeStyleOnly(response.getWriter( ));
	TableImpl.printCommonScript(response.getWriter());
	JSHelper.printJsInclude( response.getWriter(), JSHelper.JQUERY_JS );
	String contextName = context.getContextId();
	String[] locks = context.getValues( "cLocks" );
	String onUnload = (locks == null || locks.length == 0?"":" onUnload='unlockStudy();'");
	
%>
<script>
	var needUnlock=0; // mostly not needed, should be set where appropriate

  function unlockStudy() {
  	var dataPart='cContext=<%=request.getParameter("cContext")%>&cIMLockID=';
    if (needUnlock) {
		try {
			console.log( "unlocking started" );
		}
		catch (e){}
		if ( navigator && navigator.sendBeacon ) {
			navigator.sendBeacon( '/cases/unlockwindow.jsp?' + dataPart );
		}
		else {
			$.ajax({
  				type: 'POST',
  				url: '/cases/unlockwindow.jsp',
  				data: dataPart, 
				async:false,
				success: function() {
					needUnlock = false;
					try {
						console.log( "unlocking succeeded" );
					}
					catch (e){}
			    },
				error: function (xhr, ajaxOptions, thrownError) {
					try {
						console.log( "unlocking failed:" );
				    	console.log(xhr.status);
				    	console.log(thrownError);
					}
					catch (e){}
				}
			});
		}
    }
  }

	$(document).ready(function(){
		window.onbeforeunload = function(){
			unlockStudy();
		}
	});
	
	
	function jump(host, context, study, intid, isFirst, isLast, isSelected, lockID) {
		needUnlock=0;
		document.location.href=host+"/cases/reportview.jsp?cContext="+context+"&cOp=batchApprove&cGr="+study+"&cIMLockID="+lockID+"&cIntID="+intid+"&cIsFirst="+isFirst+"&cIsSelected="+isSelected+"&cIsLast="+isLast+"#section_"+intid;
	}
	
	function postModify(uid, shouldApprove) {
		self.document.postModifyForm.cCurrentID.value=uid;
		if (shouldApprove) {
			self.document.postModifyForm.cOp.value="approve";
		}
		else {
			self.document.postModifyForm.cOp.value="unapprove";
		}
		needUnlock=0;
		self.document.postModifyForm.submit();
	}
	
	var operInProgress = false;
	
	function oper(oper) {
		if ( operInProgress ) {
			// prevent multiple clicks
			return;
		}
		operInProgress = true;
		self.document.operForm.cOp.value=oper;
		needUnlock=0;
		self.document.operForm.submit();
	}
	
</script>
<style>
table {
  border-collapse: collapse;
  line-height: 2em;
  margin-top: 2px;
  border: medium none;
  width: 100%;   
  color: #222;
}

table td {
	border: none;
}

table tr.HeaderRow {
    background-color: #f2f2f2;
}

table .FieldBlockB {
  background: #f2f2f2;
  border-bottom: 1px solid #666;
}

table .FieldBlockT {
  background: #f2f2f2;
}

table .FieldBlockC {
  background: none repeat scroll 0 0 #f2f2f2;
}
</style>
</head>
<BODY<%=onUnload%>>
<!--<%=Helper.request2String(request)%>-->
<%
	//  TabToolbox.makeTabs( sess,sess.tabbean, "cases/index.jsp", "White");

// 	Helper.DEBUG("batchReportApprove.jsp", "context sess "+contextName);
  if ("bAp".equals(request.getParameter("cInstr"))) { // create context and redirect.
  	Helper.DEBUG("batchReportApprove.jsp", "generating context.");
	String backURL = context.getValue( "cBack" );
	if (backURL == null || backURL.length() == 0) {
		backURL = request.getHeader("REFERER");
	}
	if (backURL == null || backURL.length() == 0) {
		backURL = "/cases/index.jsp";
	}

	String[] parStudy = (String[])request.getParameterValues( "cGr");
		
	if (parStudy == null || parStudy.length == 0) {
		throw new IMGeneralException( LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_BATCHREPORTSIGN_SELECT_STUDY" ) , "cases/index.jsp", LocalizedMessage.getSimpleMessage( "GENERAL_BATCH_ERROR_TITLE" ), backURL);
	}
	List<String> studyList = Arrays.asList(parStudy);

  	// check for preliminary interpretations...
  	boolean breakLocks = "true".equals( request.getParameter( "cBreakLocks" ) );
  	boolean hasBreakLockRight = sess.getRights(  ).hasRight( PacsRight.BreakLock );
  	List<String> goodStudies = new ArrayList<String>();
  	List<String> lockedStudies = new ArrayList<String>();
  	List<String> goodRPs = new ArrayList<String>();
  	Map<String, String> rp2StudyMap = new HashMap<String, String>();
  	List<String> badStudies = new ArrayList<String>();
  	List<String> readOnlyStudies = new ArrayList<String>();
  	List<String> duplicateStudies = new ArrayList<String>();
  	String query = "select INTSOPIUID from "+IMEnvBase.getEnv("REPORTTBL")+" where ISTATUS='" + IMTypeos.APPROVABLE_DICOM_STATUS_ID + "' AND SRCSTUDY='";
  	Statement st = IMEnv.getDB().createStatement();
  	Set<String> srcStudies = new HashSet<String>();
  	for (String study:parStudy) {
  		srcStudies.add( StudyToolbox.getSourceStudyDB(study) );
  	}
  	Map<String, LockDescriptor> lockPrpMap = AkacFacade.getLockInfo( sess, srcStudies.toArray( new String[srcStudies.size()] ) );
  	srcStudies.clear();
  	for (int i=0; i<parStudy.length; i++) {
  		String study = parStudy[i];
  		String srcStudy = StudyToolbox.getSourceStudyDB(study);
  		if (srcStudies.contains(srcStudy)) {
  			duplicateStudies.add(study);
  			continue;
  		}
  		srcStudies.add(srcStudy);
		StoreState storestate = new StoreState(srcStudy);
		storestate.load();
		if ("yes".equals(storestate.getAttribute("DontEdit"))) {
			readOnlyStudies.add(study);
			continue;
		}
  		ResultSet rs = st.executeQuery(query+srcStudy+"'");
  		while (rs.next()) {
  			String srsopiuid = rs.getString("INTSOPIUID");
  			String rpid = Helper.encodeList(new String[] {srcStudy, srsopiuid});
 				goodRPs.add(srsopiuid);
 				rp2StudyMap.put(srsopiuid, study);
  		}
  		if (!rs.first()) {
  			badStudies.add(study);
  		}
  		else {
  			String userId = sess.getUser().getUserId();
  			LockDescriptor lockDesc = lockPrpMap.get( srcStudy );
  			String lockerId = lockDesc.getLockOwner();
  			
  			if ( lockerId == null ) {
  				//no lock, lock the study
	  			goodStudies.add(study);
  			} 
  			else {
  				if (!breakLocks){
    				// the study is locked by someone else and we were not told to break it
  					lockedStudies.add(study);
  				} else {
  					goodStudies.add(study);
  				}
  			}
  		}
  	}
  	if (badStudies.size() > 0 || readOnlyStudies.size() > 0 || lockedStudies.size() > 0 || duplicateStudies.size() > 0) {
	String errFontB = "<FONT color=red><B>";
	String errFontE = "</b></FONT>";
	if (badStudies.size() > 0) {
  		// warn about skipping unknown/non-preliminary studies%>
<center>
	<P><%=errFontB%><%= badStudies.size() > 1 ? LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_BATCHREPORTSIGN_NO_PRELIM_INTERP_PLURAL" ) : LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_BATCHREPORTSIGN_NO_PRELIM_INTERP" ) %>:
		<table> <tr> <td> <%=OperToolbox.getPatientNames(sess, badStudies.toArray(new String[0]), new BrowserInfo(), false, false, null).getStudiesTable()%>
		</td></tr></table><%=errFontE%>
<%		}
			if (readOnlyStudies.size() > 0) {
  		// warn about skipping read-only studies%>
	<P><%=errFontB%><%= readOnlyStudies.size() > 1 ? LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_BATCHREPORTSIGN_READ_ONLY_PLURAL" ) : LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_BATCHREPORTSIGN_READ_ONLY" ) %>:
		<table> <tr> <td> <%=OperToolbox.getPatientNames(sess, readOnlyStudies.toArray(new String[0]), new BrowserInfo(), false, false, null).getStudiesTable()%>
		</td></tr></table><%=errFontE%>
<%		}
			if (duplicateStudies.size() > 0) {
	  		// warn about skipping duplicate studies/links%>
		<P><%=errFontB%><%= duplicateStudies.size() > 1 ? LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_BATCHREPORTSIGN_DUPLICATE_PLURAL" ) : LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_BATCHREPORTSIGN_DUPLICATE" ) %>:
			<table> <tr> <td> <%=OperToolbox.getPatientNames(sess, duplicateStudies.toArray(new String[0]), new BrowserInfo(), false, false, null).getStudiesTable()%>
			</td></tr></table><%=errFontE%>
	<%		}
			if (lockedStudies.size() > 0) {
  		// warn about breaking/skipping locked studies%>
	<P><%=errFontB%>
	<%= lockedStudies.size() > 1 ? LocalizedMessage.getSimpleMessage( 
			hasBreakLockRight ? "EXCEPTION_CASES_BATCHREPORTSIGN_LOCKED_PLURAL" : "EXCEPTION_CASES_BATCHREPORTSIGN_NON_LOCKABLE_PLURAL" 
					) : LocalizedMessage.getSimpleMessage( hasBreakLockRight ? "EXCEPTION_CASES_BATCHREPORTSIGN_LOCKED" : "EXCEPTION_CASES_BATCHREPORTSIGN_NON_LOCKABLE" ) %>
			<%	if (hasBreakLockRight) { %>
					
	<%=(goodStudies.size() > 0?(", "+(lockedStudies.size()>1?LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_BATCHREPORTSIGN_OR_SKIP_PLURAL" ): LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_BATCHREPORTSIGN_OR_SKIP" ) )):"")%>
		<%		} %>:
		<table> <tr> <td> <%=OperToolbox.getPatientNames(sess, lockedStudies.toArray(new String[0]), new BrowserInfo(), false, false, null).getStudiesTable()%>
		</td></tr></table><%=errFontE%>
					
<%			}
%>
	<P>
	<form>
		<a href="<%=backURL%>"><%= JSHelper.getJsLocalizedButton( "BUTTON_BACK", "BUTTON_NULL", false ) %></a>
	</form>
	
	<table><tr>
	<%
  		if (goodStudies.size() > 0) { %>
	<td>
	<FORM name="operForm1" method="POST" action="batchReportSign.jsp">
	<input type=hidden name="cBack" value="<%=backURL%>">
	<input type=hidden name="cInstr" value="bAp">
	<%		for (int i=0; i<goodStudies.size(); i++) {%>
	<input type=hidden name="cGr" value="<%=goodStudies.get(i)%>">
	<%		}%>
<%= JSHelper.getJsInputLocalizedButton( new BrowserInfo(), "BUTTON_SKIP_THEM", "", "" ) %>
</form>
	</td>
<%  	}
  		if (lockedStudies.size() > 0 && hasBreakLockRight) { %>
	<td>
	<FORM name="operForm2" method="POST" action="batchReportSign.jsp">
	<input type=hidden name="cBack" value="<%=backURL%>">
	<input type=hidden name="cInstr" value="bAp">
	<input type=hidden name="cContext" value="<%=contextName%>">
	<%		for (int i=0; i<goodStudies.size(); i++) {%>
	<input type=hidden name="cGr" value="<%=goodStudies.get(i)%>">
	<%		}%>
	<%		for (int i=0; i<lockedStudies.size(); i++) {%>
	<input type=hidden name="cGr" value="<%=lockedStudies.get(i)%>">
	<%		}%>
	<input type=hidden name="cBreakLocks" value="true">
<%= JSHelper.getJsInputLocalizedButton( new BrowserInfo(), "BUTTON_BREAK", "", "" ) %>
</form>
	</td>
<%  	}%>
	</tr></table>
	</center>
<%		return;
		}

  	List<String> myLockIDs = new ArrayList<String>();
		// everything is ready, we may lock the studies now.
		Map<String, LockResult> lockResMap = AkacFacade.lockStudies( sess, goodStudies.toArray(new String[goodStudies.size()]), hasBreakLockRight );
		for (String study : goodStudies ) {

			if (!lockResMap.containsKey( study ) || !lockResMap.get(study).m_succeeded) {
				// release lock and throw RuntimeException...
				Map<String, String> lockIDs = new HashMap<String, String>();
				for (String stdy:lockResMap.keySet()) {
					LockResult lr = lockResMap.get( stdy );
					if ( lr.m_succeeded ) {
						lockIDs.put( stdy, lr.m_lockId );
					}
				}
				try {
					AkacFacade.unlockStudies( sess, lockIDs );
				}
				catch ( Exception e ) {
					Helper.defaultCatch( e );
				}
				throw new RuntimeException("Locking study "+study+" failed." );
			}
			String myLockID = Helper.encodeList(new String[] {study, lockResMap.get(study ).m_lockId});
			myLockIDs.add(myLockID);
		}

  		contextName = context.getContextId();
		if (backURL.indexOf("?") > 0) {
			backURL += "&cDisposableContext="+contextName;
		}
		else {
			backURL += "?cDisposableContext="+contextName;
		}

		context.setValue( "cBack", backURL);
		context.setValues( "cSelectedRPs", new String[0]);
		context.setValues( "cRPID", goodRPs.toArray(new String[0]));
		context.setValues( "cRPIDMap", BatchApproveToolbox.encodeProps(rp2StudyMap));
		context.setValues( "cLocks", myLockIDs.toArray(new String[0]));
		context.delValue( "cGr" );
		context.delValue( "cInstr");
		context.delValue( "r_no_refresh");
		// at first none of the reportparts are selected for approval
		context.save();
		%>
<script language="JavaScript">
	document.location.href="/cases/batchReportSign.jsp?cContext=<%=contextName%>";
</script>
<%
		return;
  }
  
  // ---------------------------- end of init part -------------------------------------
  
  String[] parRPIDs = context.getValues( "cRPID" );
	Map<String, String> rp2StudyMap = BatchApproveToolbox.decodeProps( context.getValues( "cRPIDMap" ) );
  if (parRPIDs == null) {
  	parRPIDs = new String[0];
  }
  List<String> rpidList = new ArrayList<String>();
  rpidList.addAll(Arrays.asList(parRPIDs));
  String[] selectedRPIDs = context.getValues( "cSelectedRPs" );
  if (selectedRPIDs == null) {
  	selectedRPIDs = new String[0];
  }
  List<String> selectedRpidList = new ArrayList<String>();
  selectedRpidList.addAll(Arrays.asList(selectedRPIDs));
	String currentID = context.getValue( "cCurrentID" );
	if (currentID == null || currentID.equals("")) {
		currentID = parRPIDs[0];
	}
	
	int index = rpidList.indexOf(currentID);
	String cOper = context.getValue( "cOp" );
	if ("abortUnlock".equals(cOper)) {
		BatchApproveToolbox.abortUnlocking(sess.getSessionId(  ));
		%>
		<script language="JavaScript">
			window.close();
		</script>
		<%
		return;
	}
	if ("approve".equals(cOper) || "unapprove".equals(cOper)) {
		if ("approve".equals(cOper) && !selectedRpidList.contains(currentID)) {
			selectedRpidList.add(currentID);
		}
		if ("unapprove".equals(cOper) && selectedRpidList.contains(currentID)) {
			selectedRpidList.remove(currentID);
		}
		context.setValues("cSelectedRPs", selectedRpidList.toArray(new String[0]));
		context.save();
		if (index < rpidList.size()-1 && request.getParameter("cFinishAfter") == null) {
			cOper = "next";
		}
		else {
			cOper = "finish";
		}
	}
	if ("next".equals(cOper)) {
		boolean foundNext = false;
		boolean changed=false;
		index++;
		while (index < rpidList.size() && !foundNext) {
			currentID = rpidList.get(index);
			
			if (!BatchApproveToolbox.exists(currentID)) {
				rpidList.remove(index);
				changed=true;
			}
			else {
				foundNext=true;
			}
		}
		if (!foundNext) {
			index--;
			currentID = rpidList.get(index);
			while (!BatchApproveToolbox.exists(currentID)) {
				rpidList.remove(index);
				changed=true;
				index--;
				if (index < 0) {
					cOper="cancel";
					break;
				}
				currentID = rpidList.get(index);
			}
		}
		if (changed) {
			context.setValues("cRPID", rpidList.toArray(new String[0]));
			context.save();
		}
	}
	if ("prev".equals(cOper)) {
		boolean foundPrev = false;
		boolean changed = false;
		index--;
		while (index > -1 && !foundPrev) {
			currentID = rpidList.get(index);
			
			if (!BatchApproveToolbox.exists(currentID)) {
				rpidList.remove(index);
				index--;
				changed=true;
			}
			else {
				foundPrev=true;
			}
		}
		if (!foundPrev) {
			index++;
			currentID = rpidList.get(index);
			while (!BatchApproveToolbox.exists(currentID)) {
				rpidList.remove(index);
				changed=true;
				if (index == rpidList.size()) {
					cOper="cancel";
					break;
				}
				currentID = rpidList.get(index);
			}
		}
		if (changed) {
			context.setValues("cRPID", rpidList.toArray(new String[0]));
			context.save();
		}
	}
	if ("cancel".equals(cOper)) {
		String cBackURL= context.getValue("cBack");
		BatchApproveToolbox.doInstantUnlocking(sess, context.getValues("cLocks" ));
		%>
<script language="JavaScript">
	document.location.href="<%=cBackURL%>";
</script>
<%
	return;
	}
	if ("finish".equals(cOper)) { 
		String cBackURL = context.getValue("cBack");
  	if ("true".equals(request.getParameter("doApproving"))) { // do the job
   		List<String> failedOnes = new ArrayList<String>();
   		List<String> failedOnes2 = new ArrayList<String>();
	String qObject = "SELECT ITYPE,ISTATUS FROM " + IMEnvBase.getEnv("REPORTTBL") + " WHERE INTSOPIUID=?";
	PreparedStatement stObject = IMEnv.getDB().prepareStatement(qObject);
	   	for (int i=0; i<selectedRpidList.size(); i++) {
  	 		String sopiuid = selectedRpidList.get(i);
   			stObject.setString(1,sopiuid);
		ResultSet rs = stObject.executeQuery();
		if (!rs.first()) {
			failedOnes2.add( LocalizedMessage.getCompoundMessage( "CASES_BATCHREPORTSIGN_STUDY_DELETED", new Format[] { null }, new Object[] { sopiuid }, false ) );
			continue;
		}
		String status = rs.getString("ISTATUS");
		if (!status.equals( IMTypeos.APPROVABLE_DICOM_STATUS_ID )){
			status = ((IMTypeISTI) IMType.getTypeForColid("ISTI")).displayText(sess, rs.getString("ISTATUS"));
			failedOnes2.add( LocalizedMessage.getCompoundMessage( "CASES_BATCHREPORTSIGN_STUDY_STATUS_CHANGED", new Format[] { null, null }, new Object[] { sopiuid, status }, false ) );
			continue;
		}
	   		String study = rp2StudyMap.get(sopiuid);
  	 		String typeID = rs.getString("ITYPE");
   			if (!ReportToolbox.doApprove(sess, study, sopiuid, typeID, false, IMLock.getLockIDFromRequest( context, request, study )) && !failedOnes.contains(study)) {
   				failedOnes.add(study);
	   		}
  	 	}
   		if (failedOnes.size() > 0 || failedOnes2.size() > 0) { // errors to be indicated
   			if (failedOnes2.size() > 0) {
%>
<center>
<H2><font color=red><%= (failedOnes2.size() > 1 ? LocalizedMessage.getSimpleMessage( "CASES_BATCHREPORTSIGN_CANNOT_APPROVE_FOLLOWING_INTERPRETATION_PLURAL" ) : LocalizedMessage.getSimpleMessage( "CASES_BATCHREPORTSIGN_CANNOT_APPROVE_FOLLOWING_INTERPRETATION" ) ) %>:</font>
<table>
<%
					for (int i=0; i<failedOnes2.size(); i++) {%>
						<tr><td><%=""+failedOnes2.get(i)%></td></tr>
<%				}%>
</table></h2></center>
<%			}
				if (failedOnes.size() > 0) {
%>
<center><H2><font color=red><%= (failedOnes.size() > 1 ? LocalizedMessage.getSimpleMessage( "CASES_BATCHREPORTSIGN_REPORT_SAVING_FAILED_PLURAL" ) : LocalizedMessage.getSimpleMessage( "CASES_BATCHREPORTSIGN_REPORT_SAVING_FAILED" ) ) %>:</font>
<table> <tr> <td> <%=OperToolbox.getPatientNames(sess, failedOnes.toArray(new String[0]), new BrowserInfo(), false, false, null).getStudiesTable()%>
		</td></tr></table></h2></center>
<%			}%>
<form action="/cases/unlockwindow.jsp" method=post>
<input type=hidden name="cBackURL" value="<%=cBackURL%>">
<script language="JavaScript">
	needUnlock=1;
	//getInputButton("Back", "cContext", "<%=contextName%>");
</script>
<%= JSHelper.getJsInputLocalizedButton( new BrowserInfo(), "BUTTON_BACK", "cContext", contextName ) %>
</form>
<%   	}
	   	else { // no problem
%><center><H2><%= LocalizedMessage.getSimpleMessage( "CASES_BATCHREPORTSIGN_OPERATION_COMPLETED" )  %>.</h2></center>
<%
			  out.flush();
				BatchApproveToolbox.doInstantUnlocking(sess, context.getValues("cLocks" ));
				Thread.sleep(2000);
%>
	<script language="JavaScript">
	document.location.href="<%=cBackURL%>";
	</script>
<%   	}
    }
   	else { // confirm (unlock mechanism needed here...)
%>
<TABLE border=1 width="100%" cellpadding=0 cellspacing=0 class=BgShadow>
	<tr>
		<td>
			<BR>
			<TABLE border=0 width="100%">
				<TR>
					<TD>
						&nbsp;&nbsp;
						<FONT size=4>
						<%= LocalizedMessage.getSimpleMessage( "CASES_BATCHREPORTSIGN_INTERPRETATIONS_TO_BE_APPROVED" ) %>:
						</FONT>

					</TD>
				</tr>
			</table>
			<br>
		</td>
	</tr>
	<form name="postModifyForm" method=get>
		<input type=hidden name="cContext" value="<%=contextName%>">
		<input type=hidden name="cCurrentID" value="">
		<input type=hidden name="cOp" value="">
		<input type=hidden name="cFinishAfter" value="true">
	</form>
	<TR>
		<td>
<% 	
			Set<String> studies = new HashSet<String>();
	 		Map<String, List<String>> studyMap = new HashMap<String, List<String>>();
	 		List<String> allStudies = new ArrayList<String>();
 			boolean multiple = false;
			for (int i=0; i<parRPIDs.length; i++) {
 	 			String sopiuid = parRPIDs[i];
 				String study = rp2StudyMap.get(sopiuid);
	 			if (!studyMap.containsKey(study)) {
 					allStudies.add(study);
 					studyMap.put(study, new ArrayList<String>());
 				}
 				else {
 					multiple=true;
	 			}
 				studyMap.get(study).add(sopiuid);
			}
			String table = "<table border=1 cellspacing=0 cellpadding=0 width=\"100%\">\n";
			//String header = "Patient name, Patient ID, Modality, Study Date";
			String header = LocalizedMessage.getLocalFieldName( "FIELD_PANM" ) + ",";
			header += LocalizedMessage.getLocalFieldName( "FIELD_PAID" ) + ",";
			header += LocalizedMessage.getLocalFieldName( "FIELD_MODY" ) + ",";
			header += LocalizedMessage.getLocalFieldName( "FIELD_SYDT" ) + ",";
			header += LocalizedMessage.getLocalFieldName( "FIELD_TRAD" ) + ",";
			header += LocalizedMessage.getLocalFieldName( "FIELD_SYDT" ) + ",";
			header += LocalizedMessage.getLocalFieldName( "FIELD_ITDT" ) + ",";
			header += LocalizedMessage.getSimpleMessage( IMTypeos.LAST_DICOM_STATUS_ID );
			
			
//			if (multiple) {
				//header += ", Radiologist, Transcription date";
//			}
			//header += ", Approved";
			int colnum = 6;
			table += Helper.header3D(header) + "\n";
			
			for (int j=0; j<allStudies.size(); j++) {
				String study = allStudies.get(j);
				ResultSet rs1 = IMEnv.getDB().createStatement().executeQuery("select PNAME,PID,MODALITY,THEDATETIME from "+IMEnvBase.getEnv("STUDYTBL")+" where STYIUID='"+study+"'");
				rs1.first();
				String pname = IMType.getTypeFor("PN").displayText(sess, rs1.getString("PNAME"));
				String pid = rs1.getString("PID");
				String modality = rs1.getString("MODALITY");
				String studyDate = IMType.getTypeFor("Dt").displayText(sess, rs1.getString( "THEDATETIME" ));
				List<String> parts = studyMap.get(study);
				table += "<tr><td colspan="+colnum+"></td></tr>\n<tr>\n<td>"+pname+"</td>\n<td>"+pid+"</td>\n<td>"+modality+"</td>\n<td>"+studyDate+"</td>\n";
				for (int i=0; i<parts.size(); i++) {
					if (i>0) {
						table += "<tr>\n<td colspan=4>&nbsp;</td>\n";
					}
					String sopiuid = parts.get(i);
					ResultSet rs = IMEnv.getDB().createStatement().executeQuery("select IAUTHOR,ITSCDATETIME,INTID,ISTATUS from "+IMEnvBase.getEnv("REPORTTBL")+" where INTSOPIUID='"+sopiuid+"'");
					rs.first();
					String author = IMType.getTypeFor("PN").displayText(sess, rs.getString("IAUTHOR"));
					String recDate = IMType.getTypeFor("Dt").displayText(sess, rs.getString("ITSCDATETIME"));
					String intID = rs.getString("INTID");
					String host = "";
					if ( DotcomConfig.selfDevice().isDbOnly()) {
						host = RedirectToolbox.getClosestRedirectForStudy(sess, study);
					}
					boolean sessFirst = i==0 && j==0;
					boolean sessLast = i==parts.size()-1 && j==allStudies.size()-1;
					boolean sessSelected = selectedRpidList.contains(sopiuid);
					String link = "<a href=\"JavaScript:jump('"+host+"', '"+contextName+"', '"+study+"', '"+intID+"', "+
						sessFirst+", "+sessLast+", "+sessSelected+", '"+ IMLock.getLockIDFromRequest( context, request, study ) +"')\">";
					String status = rs.getString("ISTATUS");
					table += "<td>"+link+author+"</a></td>\n";
					table += "<td>"+link+recDate+"</a></td>\n";
					String link2 = "<a href=\"JavaScript:postModify('"+sopiuid+"'"+(selectedRpidList.contains(sopiuid)?"":", 'true'")+")\">";
					table += "<td align=center>"+link2+"<img src=\"/imadmin/art/"+(selectedRpidList.contains(sopiuid) && ReportToolbox.getState(sess, sopiuid).equals("Preliminary")?"check":"cross")+".gif\"></a></td>\n";
					table += "</tr>\n";
				}
			}
			table += "</table>";
			table += "</td>";
			table += "</tr>";
			table += "<tr>\n";
			table += "<td align=right>\n";
			table += "<form name=\"operForm\" method=post action=\"batchReportSign.jsp\" onSubmit='needUnlock=0;'>\n";
			table += "<input type=hidden name=\"cContext\" value=\""+contextName+"\">\n";
			table += "<input type=hidden name=\"cOp\" value=\"\">\n";
			if (selectedRpidList.size() > 0) {
				table += "<a href=\"JavaScript:oper('lastConfirm')\">"+JSHelper.getJsLocalizedButton( "BUTTON_APPROVE", "BUTTON_NULL", false ) +"</a>\n";
				table += "&nbsp;&nbsp;";
			}
			table += "<a href=\"JavaScript:oper('cancel')\">" + JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false ) + "</a>\n";
			table += "&nbsp;&nbsp;\n";
			table += "</form>\n";
			out.println(table);
			%>
		</td>
	</tr>
</table>
<Script language="JavaScript">
	needUnlock=1;
</script>
<%
		}
   	return; // if some kind of finish...
  }
  if ("lastConfirm".equals(cOper)) {
%>
		<BR>
		<center>
			<FONT size=4>
				<%= LocalizedMessage.getSimpleMessage( "CASES_BATCHREPORTSIGN_FINAL_MSG" ) %>
			</FONT>
			<form name="operForm" method=post action="batchReportSign.jsp" onSubmit='needUnlock=0;'>
				<input type=hidden name="cContext" value="<%=contextName%>">
				<input type=hidden name="doApproving" value="true">
				<%
				out.println("<br><br>");
				if (selectedRpidList.size() > 0) {
				//Button.printJsInputButton(sess, "Approve", "cOp", "finish");
				out.println("<a href=\"JavaScript:oper('finish')\">"+JSHelper.getJsLocalizedButton( "BUTTON_APPROVE", "BUTTON_NULL", false ) +"</a>\n");
				out.println("&nbsp;&nbsp;");
			}
			//Button.printJsInputButton(sess, "Cancel", "cOp", "cancel");
			out.println( JSHelper.getJsInputLocalizedButton( new BrowserInfo(), "BUTTON_CANCEL", "cOp", "cancel" ) );
			%>
			</form>
			</center>
<Script language="JavaScript">
	needUnlock=1;
</script>
<%
		return;
  }
	// jump to the actual ReportPart
	ResultSet rs = IMEnv.getDB().createStatement().executeQuery("select INTID from "+IMEnvBase.getEnv("REPORTTBL")+" where INTSOPIUID='"+currentID+"'");
	if (!rs.first()) {
		throw new IMException("Something nasty has happened around the database. (the reportpart "+currentID+" has disappeared)");
	}

	String[] selectedRPs = context.getValues("cSelectedRPs");
	boolean sessSelected = selectedRpidList.contains(currentID);
	String[] allRPs = context.getValues("cRPID");
	boolean sessFirst = index == 0;
	boolean sessLast = index == rpidList.size() - 1;
	String study = rp2StudyMap.get(currentID);
	String lockID = IMLock.getLockIDFromRequest( context, request, study );
//	if (lockID == null) {
//		throw new IMException("LockID missing for study "+study+". "+Helper.session2String( sess ));
//	}
	String host = "";
	if ( DotcomConfig.selfDevice().isDbOnly() ) {
		host = RedirectToolbox.getClosestRedirectForStudy(sess, study);
		study += "&ParentSession="+sess.getSessionId(  )+"&RefererHost="+RedirectToolbox.getThisHostEnc(request);
	}
%>
<script language="JavaScript">
	jump("<%=host%>", "<%=contextName%>", "<%=study%>", "<%=rs.getString("INTID")%>", <%=sessFirst%>, <%=sessLast%>, <%=sessSelected%>, '<%=lockID%>');
</script>