<%--
 * Component: cases
 *
 * Description:
 *    sets the current viewed-state of a study to the state shown in a given viewer session.
 *
 * @param cStudy          Study Instance UID of study to perform operation on
 * @param ViewSessionID   ViewerSessionID identifying the viewer that has the study open
 * @param studyState			studystate from the vid file (in case of redirection)
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@page import="com.erad.pacs.modules.gwt.session.right.PacsRight"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="com.erad.pacs.common.interfaces.AkacFacade"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.akac.Akac"%>
<%@
	page import="java.io.*, java.util.*, imagemed.dotcom.*, imagemed.exception.*, imagemed.imsession.*,
			imagemed.jsputil.*, imagemed.types.flag.IMTypeur, imagemed.util.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%

	// TODO: Should not this be redirected ????
	
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSessionNoSessParCheck( request, response );

	String strViewSessionID = request.getParameter( "ViewSessionID" );
	String study = request.getParameter( "cStudy" );
	if ( !IfaceToolbox.isRegOK( sess, true ) ) {
		Helper.DEBUG( "clearchangeflag.jsp", "No registration info for this IP" );
		return;
	}
	if ( ! sess.getRights().hasRight( PacsRight.Report ) ) {
		Helper.DEBUG( "clearchangeflag.jsp", "This page requires Report right." );
		out.println( "This page requires Report right." );
		return;
	}

	if ( strViewSessionID == null || strViewSessionID.length() == 0 ) {
		Helper.DEBUG( "clearchangeflag.jsp", "The required parameter \"ViewSessionID\" is missing." );
		out.println( "The required parameter \"ViewSessionID\" is missing." );
		return;
	}
	
	if ( study == null || study.length() == 0 ) {
		Helper.DEBUG( "clearchangeflag.jsp", "The required parameter \"cStudy\" is missing." );
		out.println( "The required parameter \"cStudy\" is missing." );
		return;
	}
	
	String lockId = null;
	if ( request.getHeader( "IMLockID" ) != null && request.getHeader( "IMLockID" ).length() > 0 ) {
		lockId = request.getHeader( "IMLockID" );
	} else if ( request.getParameter( "cIMLockID" ) != null && request.getParameter( "cIMLockID" ).length() > 0 ) {
		lockId = request.getParameter( "cIMLockID" );
	}
	
	if (! AkacFacade.isLockIdValid( sess, study, lockId )){
		Helper.DEBUG( "clearchangeflag.jsp", "checkLock on OwnerDevice failed, isLockIdValid returns false.");
		out.println( "Checking lock failed." );
		return;		
	}

	String studyState = request.getParameter( "studyState" );
	if ( studyState == null || studyState.length() == 0 ) {
		studyState = VIDManager.getStudyFingerPrintStringFromVID( strViewSessionID, study, false );
	}
	
	if ( studyState == null || studyState.length() == 0 ) {
		Helper.DEBUG( "clearchangeflag.jsp", "The viewer session seems to be corrupt (missing vid file or vid file does not contain information about this study)." );
		out.println( "The viewer session seems to be corrupt (missing vid file or vid file does not contain information about this study)." );
		return;
	}
	
	String proxyID = Dotcom.getProxyID( study, false );
	if ( proxyID != null ) {
		if ( Proxy.issueAndCheckProxyURL( sess, proxyID, "/cases/clearchangeflag.jsp",
				"cStudy=" + study + "&studyState=" + Helper.URLEncodeUTF8( studyState ) +
				"&ViewSessionID=" + strViewSessionID, new Properties() ) ) {
			out.println( "OK" );
		}
		else {
			out.println( "FAILED" );
		}
		return;
	}

	try {
		File tmpStateFile = File.createTempFile( "state", ".txt", new File( IMEnvBase.getEnv( "TMP" ) ) );
		Helper.writeTextFile( tmpStateFile.getAbsolutePath(), studyState );
		String filenameMod = IMEnvBase.getEnv( "TMP" ) + "/dcmmod.PbR." + System.currentTimeMillis() + "." + Helper.getCounter();
		StringBuilder dump = new StringBuilder( "(f215,1043) SQ #      PBOverWriteSequence     1       ImageMedical\n" );
		dump.append( "(fffe,e000) na (Item with explicit length #=3)          #  66, 1 Item\n");
		dump.append( "(f215,103a) UT [FILE:" + tmpStateFile.getAbsolutePath() + "]   #  36, 1 PBStudyStateAtReportTime\n" );
		dump.append( "(fffe,e00d) na (ItemDelimitationItem for re-encoding)   #   0, 0 ItemDelimitationItem\n" );
		dump.append( "(fffe,e0dd) na (SequenceDelimitationItem for re-encod.) #   0, 0 SequenceDelimitationItem\n" );
		Helper.writeTextFile( filenameMod, dump.toString() );

		String[] cmd = new String[ 3 ];
		cmd[ 0 ] = IMEnvBase.getEnv( "DCMTK_HOME" ) + "/bin/dump2dcm";
		cmd[ 1 ] = filenameMod;
		cmd[ 2 ] = filenameMod + ".dicom";

		if ( Helper.runCommandEx( cmd, null ).getExitCode() != 0 ) {
			Helper.DEBUG( "clearchangeflag.jsp", "dump2dcm failed on file " + filenameMod );
			out.println( "dump2dcm failed on file " + filenameMod );
			return;
		}

		Helper.writeTextFile( filenameMod, null );

		cmd = new String[ 7 ];
		cmd[ 0 ] = IMEnvBase.getEnv( "DCVIEWER_HOME" ) + "/dcmmod";
		cmd[ 1 ] = "-f";
		String[] pbrs = StudyToolbox.getPbRs( study );
		if ( pbrs.length == 0 ) {
			Helper.DEBUG( "clearchangeflag.jsp", "The study seems to be corrupt (no PbR file found)." );
			out.println( "The study seems to be corrupt (no PbR file found)." );
			return;
		}
		
		String pbrFileName = pbrs[ 0 ];
		
		cmd[ 2 ] = StudyToolbox.getStudyDir( study ) + "/" + pbrFileName;
		cmd[ 3 ] = "-m";
		cmd[ 4 ] = filenameMod + ".dicom";
		
		String outputFileName = IMEnvBase.getEnv( "IMAGE_TMP" ) + "/" + study + "_" + pbrFileName; 
		File tmpOutputFile = new File( outputFileName + "." + System.currentTimeMillis() + "." + Helper.getCounter() );
		cmd[ 5 ] = "-o";
		cmd[ 6 ] = tmpOutputFile.getAbsolutePath();

		// TODO !!!
		// Put modified PbR to (data) tmp and register it in the usual way
		
		// The changed state would be updated in the Dcreg
		
		if ( Helper.runCommandEx( cmd, null ).getExitCode() != 0 ) {
			Helper.DEBUG( "clearchangeflag.jsp", "dummod failed on file " + filenameMod + ".dicom" );
			out.println( "dcmmod failed on file " + filenameMod + ".dicom" );
			tmpOutputFile.delete();
			return;
		}
		
		Helper.writeTextFile( filenameMod + ".dicom", null );

		File targetFile = new File( outputFileName );
		if ( !( Helper.renameToNotThrowsException(tmpOutputFile, targetFile) ) ) {
			tmpOutputFile.delete();
			return;
		}
		
		if ( !StudyToolbox.startStorescpRegTask( null, study, pbrFileName, "DELTA_STORESCP_REG_REPORT_EDIT", StudyToolbox.ReindexMode.OPT_NONE ) ) {
			Helper.DEBUG( "clearchangeflag.jsp", "creating StorescpReg task failed" );
			out.println( "creating StorescpReg task failed" );
			return;
		}

		
	}
	catch (IOException e) {
		Helper.DEBUG( "clearchangeflag.jsp", Helper.throwable2String( e ) );
		out.println( "IOException was caught" );
		return;
	}

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}
%>
