<%--
 * Component: cases
 *
 * Description:
 *    Performs daily tasks: purges old studies and orders.
 *
 * Params:
 *   f - pathinfo : looks like <study><fname>_<frame>[.<size>[w|t]].<ext>
 *                  9.8.7.6/CT.1.2.3.4.5_1[.size[w|t]].ext
 *  [cTargetDevice] - needs redirect to the direction of this device instead of usual
 *
 *   Thin viewer related options:
 *   x - x coordinate of topleft (?) corner of the segment to return
 *   y - y coordinate of topleft (?) corner of the segment to return
 *   w - width of the segment
 *   h - height of the segment
 * 
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.modules.gwt.exception.usermanager.SessionException"%>
<%@page import="com.erad.pacs.services.usermanager.service.internal.SessionToolbox"
%><%@page import="com.erad.pacs.services.usermanager.client.Envelope"
%><%@page import="com.erad.pacs.modules.gwt.descriptors.usermanager.SessionInfo"
%><%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.RequestConsts"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="imagemed.dotcom.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.dcprocessing.Frame,
			imagemed.http.Range, imagemed.util.*, java.io.*" %>
<%@ page trimDirectiveWhitespaces="true" %>
<%!
	static final int SIZE = 65536;//525312;

	Frame GetFrame( String pathInfo ) {
		Frame image = null;
		try {
			image = new Frame( pathInfo, false );
			image.checkAndCreateImage();
			image.checkAndReadDesc();
		}
		catch ( Throwable th ) {
			Helper.ERRORLOG( Helper.toString( th ) );
		}
		return image;
	}

	void GetBytes( HttpServletResponse response, String pathInfo, int x, int y, int w, int h ) throws IOException {
		Frame image = GetFrame( pathInfo );

		int tilex, tiley, tilew, tileh, imageWidth, imageHeight, BPP;
		tilew = -1;

		tilex = x;
		tiley = y;
		tilew = w;
		tileh = h;
		imageWidth = Integer.parseInt( image.getImageWidth() );
		imageHeight = Integer.parseInt( image.getImageHeight() );

		boolean bThumbnail = pathInfo.contains( "128x128t" );

		int actualWidth = imageWidth;
		int actualHeight = imageHeight;

		if ( bThumbnail ) {
			actualWidth = 128;
			actualHeight = 128;
		}

		BPP = Integer.parseInt( image.getImageBPP() ) / 8;

		int yin = 0;
		int idx = 0;
		int xout, xin;

		FileInputStream inStream;

		// hack to detect color image and thumbnail size
		if ( bThumbnail || ( BPP == 1 ) ) {
			File f = new File( image.getImageFileName() );
			if ( BPP == 1 ) {
				if ( f.length() > actualWidth * actualHeight )
					BPP = 3;
			}
			if ( bThumbnail ) {
				long shortDim = f.length() / ( 128 * BPP );
				if ( shortDim < 128 ) {
					if ( imageWidth > imageHeight ) {
						actualHeight = (int) shortDim;
					}
					else {
						actualWidth = (int) shortDim;
					}
				}
			}
			f = null;
		}

		imageWidth = actualWidth;
		imageHeight = actualHeight;

		byte[] ret = new byte[ w * h * BPP ];
		byte[] blankline = new byte[ w * BPP ];
		java.util.Arrays.fill( blankline, (byte) 0 );

		try {
			inStream = new FileInputStream( image.getImageFileName() );
		}
		catch ( Throwable th ) {
			Helper.ERRORLOG( Helper.toString( th ) );
			return; // null;
		}
		try {
			while ( tiley > yin ) {
				try {
					inStream.skip( imageWidth * BPP );
				}
				catch ( Throwable th ) {
					Helper.ERRORLOG( Helper.toString( th ) );
					return; // null;
				}
				yin++;
			}
			for ( int yout = 0; yout < tileh; yout++ ) {
				if ( yin < 0 || yin >= imageHeight ) {
					System.arraycopy( blankline, 0, ret, idx, w * BPP );
					idx += w * BPP;
				}
				else {
					for ( xout = 0, xin = tilex; xout < tilew; ) {
						if ( xin < 0 ) {
							System.arraycopy( blankline, 0, ret, idx, -xin * BPP );
							idx += -xin * BPP;
							xout += -xin;
							xin = 0;
						}
						else if ( xin >= imageWidth ) {
							System.arraycopy( blankline, 0, ret, idx, ( tilew - xout ) * BPP );
							idx += ( tilew - xout ) * BPP;
							break;
						}
						else {
							int nRead = Math.min( imageWidth - xin, tilew - xout );
							try {
								inStream.skip( xin * BPP );
								inStream.read( ret, idx, nRead * BPP );
								//outStream.write(scanline,0,nRead*imageBPP/8);
							}
							catch ( Throwable th ) {
								Helper.ERRORLOG( Helper.toString( th ) );
								return; // null;
							}
							idx += nRead * BPP;
							xin += nRead;
							xout += nRead;
							try {
								inStream.skip( ( imageWidth - xin ) * BPP );
							}
							catch ( Throwable th ) {
								Helper.ERRORLOG( Helper.toString( th ) );
								return; // null;
							}
						}
					}
				}
				yin++;
			}
		}
		finally {
			inStream.close();
		}
		response.setContentLength( ret.length );
		
		ServletOutputStream os = response.getOutputStream();
		os.write( ret );
		os.flush();
		os.close();
	}

%><%
	Session sess;
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );

	// check and allow localhost calls
	try {
		sess = userManager.getSessitaSessionNoSessParCheck( request, response );
	}
	catch ( SessionException se ) {
		if ( SessionToolbox.checkServerIp( request.getRemoteAddr() ) ) {
			Envelope userEnvelope = userManager.loginService( SessionInfo.SYSTEM_USERID );
			sess = userManager.checkEnvelope( request, response, userEnvelope );
		}
		else {
			throw se;
		}
	}
	//UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	//Session sess = userManager.getSessitaSessionNoSessParCheck( request, response );

	//IMSession is = new IMSession( request, response, out );
	Syslog logger = new Syslog( "frame", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );

	boolean bCheckHttpsAndRedirect = false;
	if ( ! ProxyToolbox.init( sess, null, logger ) ) {
		// There was no session checking here - consider to add something
	}

	String pathInfo = request.getParameter( "f" );
	if ( pathInfo == null )
		pathInfo = "";

	String targetDevice = request.getParameter( "cTargetDevice" );

	String study = null;
	int n = pathInfo.indexOf( "/" );
	if ( n > 0 )
		study = pathInfo.substring( 0, n );

	if ( study == null ) {
		logger.syslog( Syslog.LOG_DEBUG, "Study is null" );
		return;
	}

	//CWL, showimages calling
	String redirURL = null;
	if ( DotcomConfig.selfDevice().isDbOnly() ) {
		if ( targetDevice != null && !"".equals( targetDevice ) ) {
			redirURL = RedirectToolbox.getURL( DotcomConfig.getConfig().getServerNameTowards( targetDevice ), sess.getClientAddress().getHostAddress(), null );
		}
		else {
			redirURL = RedirectToolbox.getClosestRedirectForStudy( sess, study );
		}
	} else {
		boolean isKeyImage = false;
		try {
			isKeyImage = new Frame( pathInfo, false ).getImageQualifier().startsWith( "r" );
		}
		catch ( Throwable th ) {
			Helper.ERRORLOG( "Parsing frame "+pathInfo+" caused: "+Helper.toString( th ) );
		}
		String redirHost = isKeyImage ? null : RedirectToolbox.getClosestRedirectHostForStudy( sess, study );
		if ( redirHost != null ) {
			redirURL = RedirectToolbox.getClosestRedirectForStudy( sess, study );
		}
	}
	if ( redirURL != null ) {
		redirURL += "/cases/frame.jsp?" + request.getQueryString();
		if (request.getParameter( RequestConsts.QUERYSTRING_PARENT_SESSION_ID_NAME ) == null ) {
			redirURL += "&"+RequestConsts.QUERYSTRING_PARENT_SESSION_ID_NAME+"="+sess.getSessionId();
		}
		response.sendRedirect( redirURL );
		return;
	}

	/* proxy kikotve, amugy is false-ot adott vissza */
//	if ( ProxyToolbox.checkAndProxy( sess, study, true ) ) {
//		logger.syslog( Syslog.LOG_DEBUG, "checkAndProxy is true" );
//		return;
//	}

	if ( request.getParameter( "x" ) != null ) {
		// Request from the thin viewer
		logger.syslog( Syslog.LOG_DEBUG, "Create Response for thin viewer" );
		int x, y, w, h;

		if ( pathInfo == null || "".equals( pathInfo ) ) {
			response.setContentType( "text/plain" );
			response.sendError( 500 );
			return;
		}

		try {
			x = Integer.parseInt( request.getParameter( "x" ) );
			y = Integer.parseInt( request.getParameter( "y" ) );
			w = Integer.parseInt( request.getParameter( "w" ) );
			h = Integer.parseInt( request.getParameter( "h" ) );
		}
		catch ( Throwable th ) {
			response.setContentType( "text/plain" );
			response.sendError( 500 );
			return;
		}

		response.setContentType( "application/octet-stream" );
		response.setHeader( "Content-Transfer-Encoding", "8bit" );
		response.setCharacterEncoding( "ISO-8859-1" );

		out.clear();
		GetBytes( response, pathInfo, x, y, w, h );
		return;
	}

	logger.syslog( Syslog.LOG_DEBUG, "Create Response" );

	String fname = "";

	// check if the image exists and create it if doesn't exist
	try {
		boolean bReprocess = request.getHeader( "PBReprocess" ) != null;
		logger.syslog( Syslog.LOG_DEBUG, "Reprocess flag: " + bReprocess );

		Frame image = new Frame( pathInfo, bReprocess );
		fname = image.getImageFileName();
		image.checkAndCreateImage();
	}
	catch ( Throwable th ) {
		//response.setStatus(404);
		response.setHeader( "Content-type", "text/html" );
		String msg = "<HTML>\n<HEAD><TITLE>ERROR</TITLE></HEAD><BODY><H2>File " + fname + " not found...</H2><BR><pre>" +
				th.getMessage() + "</pre></BODY>\n</HTML>\n";
		response.setHeader( "Content-length", Integer.toString( msg.length() ) );
		out.print( msg );
		return;
	}

	response.setContentType( "image/jpeg" );

	Range range = new Range( request, response );

	try {
		range.sendRequestedRange( fname );
	}
	catch ( Throwable t1 ) {
		// not found or other I/O error
		response.setStatus(404);
	}

	if ( true ) {
		// For avoiding extra newline(s)
		return;
	}

%>
