////////////////////////////////////////////////////////////////////////////////
//
// This code is based on 
// Richtext Editor: Fork (RTEF) VERSION: 0.006
// Released: 15/01/2008
// For the latest release visit http://rtef.info
// For support visit http://rtef.info/deluxebb
//
// modified by Gyorgy Kapolnas for eRad 
// (unwanted features removed, using a DIV instead of iframe to gain autoresize)
//
////////////////////////////////////////////////////////////////////////////////

// Constants
var minWidth = 175; // minumum width
var maxchar = 64000; // maximum number of characters per save
var zeroBorder = "#c0c0c0"; // guideline color - see showGuidelines()

// Pointers
var InsertChar;
var InsertTable;
var InsertLink;
var InsertImg;
var dlgReplace;
var dlgPasteText;
var dlgPasteWord;

// we depend on LayoutScripts.js, in some cases it may not yet be loaded here...
if ( typeof getInternetExplorerVersion != 'function' ) {
	$.ajax( {
		url : "/cases/js/LayoutScripts.js",
		dataType : "script",
		async : false
	} );
}

// Strings
var selectedText = '';

// Init Variables & Attributes
var ua = navigator.userAgent.toLowerCase();
// var isIE = ( ( ua.indexOf( "msie" ) != -1 ) && ( ua.indexOf( "opera" ) == -1
// ) && ( ua.indexOf( "webtv" ) == -1 ) ) ? true : false;
var IEVersion = getInternetExplorerVersion();// parseFloat( ua.substring(
												// ua.lastIndexOf( "msie " ) + 5
												// ) );
var isOpera = ( ua.indexOf( "opera" ) != -1 ) ? true : false;
// if(isOpera) var OperaVersion =
// parseFloat(ua.substring(ua.lastIndexOf("Opera/") + 7));
// needs testing on iPhone and othere webkit based browsers
var isChrome = ( ua.indexOf( " chrome/" ) != -1 ) ? true : false;
var isSafari = ( !isChrome && ( ua.indexOf( "webkit" ) != -1 ) ) ? true : false;
var SafariVersion = parseFloat( ua.substring( ua.lastIndexOf( "webkit/" ) + 7 ) );
if ( !isSafari && !isChrome )
	var isGecko = ( ua.indexOf( "gecko" ) != -1 ) ? true : false;
else
	var isGecko = false;
// Konqueror still doen't support designmode as of 11/2007
// var isKonqueror = (ua.indexOf("konqueror") != -1)? true:false;

if ( isSafari )
	var safariDummyRange = null;

var rng;
var currentRTE;
var allRTEs = new Array();
var obj_width;
var obj_height;
var imagesPath;
var includesPath;
var cssFile;
var boldPressed = false;
var underlinePressed = false;
var italicPressed = false;
var strikeThroughPressed = false;

function setIframeNoCss( id ) {
	var Editor = document;
	try {
		Editor.execCommand( "styleWithCSS", 0, false );
	}
	catch ( e ) {
		try {
			Editor.execCommand( "useCSS", 0, true );
		}
		catch ( e ) {
			try {
				Editor.execCommand( 'styleWithCSS', false, false );
			}
			catch ( e ) {
				// alert( "Setting editor to non-css mode failed. (" + e + ")"
				// );
			}
		}
	}
	// try {
	// Editor.execCommand( 'insertBrOnReturn', false, false );
	// }
	// catch ( e ) {}
};

function rteSafe( html ) {
	// escape or convert chars that could break RTE
	var replacements = new Array( new RegExp( String.fromCharCode( 145 ), 'g' ), "'", new RegExp( String.fromCharCode( 146 ), 'g' ), "'", new RegExp( "'" ),
			"&#39;",
			// convert all types of double quotes
			new RegExp( String.fromCharCode( 147 ), 'g' ), "\"", new RegExp( String.fromCharCode( 148 ), 'g' ), "\"",
			// new RegExp("\""), "&#34;",
			// replace carriage returns & line feeds
			new RegExp( "[\r\n]", 'g' ), " " );
	html = trim( html );
	for ( var i = 0; i < replacements.length; i = i + 2 )
		html = html.replace( replacements[ i ], replacements[ i + 1 ] );
	return html;
};

function initRTE( imgPath, incPath, css, skipCss ) {
	// CM 05/04/05 check args for compatibility with old RTE implementations
	// set paths vars
	imagesPath = imgPath;
	includesPath = incPath;
	cssFile = css;
	if ( !skipCss )
		document.write( '<style type="text/css">@import "' + includesPath + 'rte.css";</style>' );
	addLoadEvent( setEventHandlers );
};

var allInitialized = false;

function setEventHandlers() {
	var doc = document;

	addEventListenerTo( doc, 'keyup', checkAll );
	addEventListenerTo( doc, 'DOMCharacterDataModified', checkAll );
	addEventListenerTo( doc, 'paste', checkAll );

	allInitialized = true;
	for ( var i = 0; i < allRTEs.length; i++ ) {
		var rte = allRTEs[ i ];
		// LayoutScripts.js should be imported for this to work
		registerInput( rte, "rte" );
		checkSize( null, rte );

		var rteInnerElement = document.getElementById( rte );
		if ( rteInnerElement != null ) {
			addEventListenerTo( rteInnerElement, 'click', checkButtonsAndFont );
			$( "#" + rte ).bind( 'paste', function( e ) {
				var el = $( this );
				setTimeout( function() {
					$( el ).find( "p:not('.pasted')" ).not( '.erad' ).each( function() {
						// add "pasted" class as first (lowest priority) class
						var newClass = "pasted";
						if ( $( this ).attr( "class" ) ) {
							newClass += " " + $( this ).attr( "class" );
						}
						$( this ).attr( "class", newClass );
					} );
				}, 4 );
			} );
		}
	}
};

function postProcessPaste() {
	$( "#" + currentRTE ).trigger( "paste" );
	checkAll( false, currentRTE );
};

/**
 * Set the font type or font size displayed according to the state of the
 * command (in a select input tag)
 * 
 * @param rte
 *            String - Name of the rte
 * @param elementName
 *            String - Name of the element involved
 * @param command
 *            String - Name of the command to be retrieved
 * @param textIncluded
 *            Boolean - if true, the select option's text may also be retrieved
 *            for the command (not only the value)
 * @param getDefaultIE
 *            String - name of the command when we try to retrieve the default
 *            in IE
 * @param getDefaultFF
 *            String - name of the command when we try to retrieve the default
 *            in FF
 * @param convert
 *            Boolean - used for size, we need to convert from 'px' to HTML
 *            absolute size
 */
function setActualCommandValue( rte, elementName, command, textIncluded, getDefaultIE, getDefaultFF, convert ) {
	var element = document.getElementById( elementName );
	var rteBox = document.getElementById( rte );
	if ( element != null ) {
		var value = "" + document.queryCommandValue( command );
		// this is needed because IE returns size as a number
		// alert( "value[0] (" + getDefaultIE + ") :" + value );
		if ( value == null || value == "null" || value == undefined || value == "" || value == "0" ) { // 0 is
																										// IE's
																										// answer
																										// for
																										// undefined
																										// size
																										// :(
			value = getCompStyle( rteBox, getDefaultFF );

			// if ( !isIE ) { // works in Opera and FF
			// value = window.getComputedStyle( rteBox, null ).getPropertyValue(
			// getDefaultFF );
			// if ( value == null || value == "" ) {
			// value = window.getComputedStyle( rteBox, null )[ getDefaultFF ];
			// }
			// }
			// else if ( rteBox.currentStyle ) { // IE (in earlier versions may
			// be integer)
			// value = "" + rteBox.currentStyle.getAttribute( getDefaultIE );
			// // alert( "value (" + getDefaultIE + ") :" + value );
			// }
		}
		if ( value != null && value != undefined && value != "" && value != "0" ) { // 0 is
																					// IE's
																					// answer
																					// for
																					// undefined
																					// size
																					// :(
			value = value.toLowerCase().trim();
			if ( convert ) { // size
				if ( value.endsWith( "px" ) ) {
					// convert to HTML absolute font sizes
					absvalue = 2;
					intvalue = parseInt( value.substring( 0, value.length - 2 ) );
					if ( intvalue <= 10 ) {
						absvalue = 1;
					}
					else if ( intvalue <= 14 ) {
						absvalue = 2;
					}
					else if ( intvalue <= 16 ) {
						absvalue = 3;
					}
					else if ( intvalue <= 19 ) {
						absvalue = 4;
					}
					else if ( intvalue <= 24 ) {
						absvalue = 5;
					}
					else if ( intvalue <= 32 ) {
						absvalue = 6;
					}
					else {
						absvalue = 7;
					}
					value = "" + absvalue;
					// alert( "converted:'" + value + "'" );
				}
			}
			// alert( command + "VALUE:'" + value + "'" );
			for ( var j = 0; j < element.options.length; j++ ) {
				// alert( "J:" + j + " Val:'" + element.options[ j
				// ].value.toLowerCase().trim() + "'" + " Text:'" +
				// element.options[ j ].text.toLowerCase().trim() + "'" );
				if ( value == element.options[ j ].value.toLowerCase().trim() || ( textIncluded && value == element.options[ j ].text.toLowerCase().trim() ) ) {
					element.selectedIndex = j;
					// alert( "Setting " + element + " to " + j );
				}
			}
		}
		else {
			element.selectedIndex = 0;
			// default
		}
	}
};

function checkAll( event, rte ) {

	if ( !rte ) {
		rte = currentRTE;
	}

	if ( document.activeElement != returnRTE( rte ) ) {
		return;
	}

	checkButtonsAndFont( event, rte );
	checkSize( event, rte );
	if ( event ) {
		var unicode = event.charCode ? event.charCode : event.keyCode;
		if ( unicode && unicode == 13 ) {
			// 13 = enter
			applyEradClass( rte );
		}
	}
};

function applyEradClass( event, rte ) {
	if ( !rte ) {
		rte = currentRTE;
	}
	var el = $( "#" + rte );
	setTimeout( function() {
		$( el ).find( "p:not([class])" ).each( function() {
			// add "erad" class to any paragraph which doesn't have any classes
			$( this ).addClass( "erad" );
		} );
	}, 0 );
};

function checkButtonsAndFont( event, rte ) {
	checkButtons( event, rte );
	checkFont( event, rte );
};

function checkButton( command, id, pressedImage, nonPressedImage ) {
	pressed = document.queryCommandState( command );
	if ( pressed == null ) {
		pressed = false;
	}

	var element = document.getElementById( id );
	if ( element != null ) {
		if ( pressed ) {
			element.src = imagesPath + pressedImage;
		}
		else {
			element.src = imagesPath + nonPressedImage;
		}
	}
}

function checkButtons( event, rte ) {
	if ( !allInitialized ) {
		return;
	}
	if ( !rte ) {
		rte = currentRTE;
	}

	checkButton( 'bold', "Bold_" + rte, "format_bold_pressed.png", "format_bold_active.png" );
	checkButton( 'italic', "Italic_" + rte, "format_italic_pressed.png", "format_italic_active.png" );
	checkButton( 'underline', "Underline_" + rte, "format_underscore_pressed.png", "format_underscore_active.png" );
	checkButton( 'strikeThrough', "StrikeThrough_" + rte, "format_strikethru_pressed.png", "format_strikethru_active.png" );

	checkButton( 'Superscript', "Superscript_" + rte, "format_superscript_pressed.png", "format_superscript_active.png" );
	checkButton( 'Subscript', "Subscript_" + rte, "format_subscript_pressed.png", "format_subscript_active.png" );

	checkButton( 'JustifyLeft', "JustifyLeft_" + rte, "format_align_left_pressed.png", "format_align_left_active.png" );
	checkButton( 'JustifyCenter', "JustifyCenter_" + rte, "format_align_center_pressed.png", "format_align_center_active.png" );
	checkButton( 'JustifyRight', "JustifyRight_" + rte, "format_align_right_pressed.png", "format_align_right_active.png" );
	checkButton( 'JustifyFull', "JustifyFull_" + rte, "format_align_justify_pressed.png", "format_align_justify_active.png" );

	checkButton( 'InsertOrderedList', "InsertOrderedList_" + rte, "format_list_number_pressed.png", "format_list_number_active.png" );
	checkButton( 'InsertunOrderedList', "InsertunOrderedList_" + rte, "format_list_bullet_pressed.png", "format_list_bullet_active.png" );

}

function checkFont( event, rte ) {
	if ( !allInitialized ) {
		return;
	}
	if ( !rte ) {
		rte = currentRTE;
	}

	// set font name and size
	setActualCommandValue( rte, "FontName_" + rte, "fontName", true, "fontFamily", "font-family", false );
	setActualCommandValue( rte, "FontSize_" + rte, "fontSize", false, "fontSize", "fontSize", true );
}

function checkSize( event, rte ) {
	if ( !allInitialized ) {
		return;
	}
	if ( !rte ) {
		rte = currentRTE;
	}

	// update counters if present
	if ( rte ) {
		count( rte );
	}
	return;
}

function writeRichText( rte, html, css, width, buttons ) {
	var lblFormat = "<option value=\"\" selected=\"selected\" onmousedown=\"setTimeout( 'focusTo(\\\'" + rte + "\\\')', 10)\" >Format</option>";
	lblFormat += "<option value=\"&lt;h1&gt;\">Heading 1</option>";
	lblFormat += "<option value=\"&lt;h2&gt;\">Heading 2</option>";
	lblFormat += "<option value=\"&lt;h3&gt;\">Heading 3</option>";
	lblFormat += "<option value=\"&lt;h4&gt;\">Heading 4</option>";
	lblFormat += "<option value=\"&lt;h5&gt;\">Heading 5</option>";
	lblFormat += "<option value=\"&lt;h6&gt;\">Heading 6</option>";
	lblFormat += "<option value=\"&lt;p&gt;\">Paragraph</option>";
	lblFormat += "<option value=\"&lt;address&gt;\">Address</option>";
	lblFormat += "<option value=\"&lt;pre&gt;\">Preformatted</option>";

	// generate the RTE interface
	if ( !html ) {
		html = "";// "&nbsp;";
	}
	currentRTE = rte;
	var rtehtml = '';
	allRTEs.push( rte );
	// CM 06/04/05 stops single quotes from messing everything up
	html = replaceIt( html, '\'', '&apos;' );
	html = html.replace( /\s/, ' ' );
	// firefox will not use paragraphs if none is present yet
	if ( false && html.indexOf( '</p>' ) == -1 && html.indexOf( '</P>' ) == -1 ) {
		html = "<p>" + html + "</p>";
	}
	// preload of the design icon (dosn't work in Opera)
	rtehtml += '<img style="display:none" src="' + imagesPath + 'design.gif" alt="preload" />';
	rtehtml += '<div class="rteDiv" id="' + rte + 'Div" style="width:' + width + ';position:relative"';
	if ( isIE )
		rtehtml += ' unselectable="on"';
	rtehtml += '>';
	if ( buttons ) {
		rtehtml += '<div class="buttons" id="buttons_' + rte + '"';
		if ( isIE )
			rtehtml += ' unselectable="on"';
		rtehtml += '>';
		rtehtml += insertBar();
		if ( !( isSafari && SafariVersion < 500 ) ) {
			rtehtml += '<select id="FormatBlock_' + rte + '" onchange="selectFont(\'' + rte + '\', this.id, true )" ';
			if ( !isIE ) {
				// timeout is not working (event undefined)
				// on IE the enter will be applied to the text field, too
				rtehtml += 'onkeypress="focusToOnEnter( event, \'' + rte + '\')"';
			}
			rtehtml += '>';
			rtehtml += lblFormat;
			rtehtml += '</select>';
		}
		if ( !( isSafari && SafariVersion < 500 ) ) {
			rtehtml += '<select id="FontName_' + rte + '" onchange="selectFont(\'' + rte + '\', this.id, false );" alt="Font" title="Font"';
			if ( !isIE ) {
				// timeout is not working (event undefined)
				// on IE the enter will be applied to the text field, too
				// rtehtml += ' onkeypress="focusToOnEnter( event, \'' + rte +
				// '\')"';
			}
			rtehtml += '>';
		}
		else
			rtehtml += '<select id="FontName_' + rte + '">';
		rtehtml += replaceIt( lblFont, "<option ", "<option onmouseup=\"setTimeout( 'focusTo(\\\'" + rte + "\\\')', 10)\" " );
		rtehtml += '</select>';
		if ( isSafari && SafariVersion < 500 )
			rtehtml += insertBn( lblApplyFont, "applyfont.gif", "selectFont('" + rte + "', 'FontName_" + rte + "', false)" );
		if ( !( isSafari && SafariVersion < 500 ) ) {
			rtehtml += '<select id="FontSize_' + rte + '" onchange="selectFont(\'' + rte + '\', this.id, false)" alt="Font Size" title="Font Size">';
			rtehtml += replaceIt( lblSize, "<option ", "<option onmouseup=\"setTimeout( 'focusTo(\\\'" + rte + "\\\')', 10)\" " );
			rtehtml += '</select>';
		}

		if ( !isIE && !isSafari ) {
			rtehtml += insertBn( lblIncreasefontsize, "increasefontsize.gif", "rteCommand('" + rte + "','IncreaseFontSize')" );
			rtehtml += insertBn( lblDecreasefontsize, "decreasefontsize.gif", "rteCommand('" + rte + "','DecreaseFontSize')" );
		}
		/*
		 * New tool bar line rtehtml += '<br />'; rtehtml += insertBar();
		 */
		rtehtml += insertSep();
		rtehtml += insertBn( lblBold, "format_bold_active.png", "rteCommand('" + rte + "','Bold')", "Bold_" + rte );
		rtehtml += insertBn( lblItalic, "format_italic_active.png", "rteCommand('" + rte + "','Italic')", "Italic_" + rte );
		rtehtml += insertBn( lblUnderline, "format_underscore_active.png", "rteCommand('" + rte + "','Underline')", "Underline_" + rte );
		if ( !( isSafari && SafariVersion < 500 ) )
			rtehtml += insertBn( lblStrikeThrough, "format_strikethru_active.png", "rteCommand('" + rte + "','StrikeThrough')", "StrikeThrough_" + rte );
		else
			rtehtml += insertBn( lblStrikeThrough, "format_strikethru_active.png", "insertHTML('<strike>'+getSelectedTextRte('" + rte + "')+'</strike>')",
					"StrikeThrough_" + rte );
		rtehtml += insertSep();
		rtehtml += insertBn( lblSuperscript, "format_superscript_active.png", "rteCommand('" + rte + "','Superscript')", "Superscript_" + rte );
		rtehtml += insertBn( lblSubscript, "format_subscript_active.png", "rteCommand('" + rte + "','Subscript')", "Subscript_" + rte );
		rtehtml += insertSep();
		rtehtml += insertBn( lblAlgnLeft, "format_align_left_active.png", "rteCommand('" + rte + "','JustifyLeft')", "JustifyLeft_" + rte );
		rtehtml += insertBn( lblAlgnCenter, "format_align_center_active.png", "rteCommand('" + rte + "','JustifyCenter')", "JustifyCenter_" + rte );
		rtehtml += insertBn( lblAlgnRight, "format_align_right_active.png", "rteCommand('" + rte + "','JustifyRight')", "JustifyRight_" + rte );
		rtehtml += insertBn( lblJustifyFull, "format_align_justify_active.png", "rteCommand('" + rte + "','JustifyFull')", "JustifyFull_" + rte );
		rtehtml += insertSep();
		if ( !( isSafari && SafariVersion < 500 ) ) {
			rtehtml += insertBn( lblOL, "format_list_number_active.png", "rteCommand('" + rte + "','InsertOrderedList', '')", "InsertOrderedList_" + rte );
			rtehtml += insertBn( lblUL, "format_list_bullet_active.png", "rteCommand('" + rte + "','InsertunOrderedList', '')", "InsertunOrderedList_" + rte );
			rtehtml += insertBn( lblOutdent, "outdent.gif", "rteCommand('" + rte + "','Outdent')" );
			rtehtml += insertBn( lblIndent, "indent.gif", "rteCommand('" + rte + "','Indent')" );
			rtehtml += insertSep();
		}
		rtehtml += insertBn( lblTextColor, "textcolor.gif", "dlgColorPalette('" + rte + "','ForeColor')", "ForeColor_" + rte );
		rtehtml += insertBn( lblBgColor, "bgcolor.gif", "dlgColorPalette('" + rte + "','hilitecolor')", "hilitecolor_" + rte );
		rtehtml += insertSep();
		if ( !( isSafari && SafariVersion < 500 ) )
			rtehtml += insertBn( lblHR, "hr.gif", "rteCommand('" + rte + "','InsertHorizontalRule', '')" );
		else
			rtehtml += insertBn( lblHR, "hr.gif", "insertHTML('<hr /><br />')" );
		rtehtml += insertSep();
		rtehtml += insertBn( lblInsertTable, "insert_table.gif", "dlgLaunch('" + rte + "','table', 450, 155)" );
		rtehtml += insertSep();
		rtehtml += insertBn( "Show HTML source", "code.gif", "showRteSource('" + rte + "')" );
		rtehtml += '</div>';
	}
	rtehtml += '<div class="rteIntDiv" onfocus="void dlgCleanUp(this);" id="' + rte + '" contenteditable=true spellcheck=true unselectable="off">' + html + '</div>';
	rtehtml += '<iframe id="cp' + rte + '" src="' + includesPath
			+ 'palette.htm" scrolling="no" frameborder=0 style="margin:-26px 0 0 0;display:none;width:142px;height:98px"></iframe>';
	rtehtml += '<input type="hidden" value="" name="' + rte + '_html" id="' + rte + '_html" />';
	rtehtml += '<input type="hidden" value="" name="' + rte + '" id="' + rte + '_text" />';
	rtehtml += '</div>';
	document.write( rtehtml );
	// enableDesignMode( rte, html, rte_css );
	document.getElementById( rte + "_html" ).value = html;
	setIframeNoCss( rte );
	applyEradClass( rte );
};

function insertBar() {
	// insert the start of a new tool bar
	return '<img class="rteBar" src="' + imagesPath + 'bar.gif" alt="" />';
};

function insertSep() {
	// insert a seporation line in the tool bar
	return '<img class="rteSep" src="' + imagesPath + 'blackdot.gif" alt="" />';
};

function insertBn( name, image, command, id ) {
	// Insert a button in the tool bar
	var img = "<img";
	if ( id != null ) {
		img = "<img id='" + id + "'";
	}
	img += ' onmousemove="return false" src="' + imagesPath + image + '" alt="' + name + '" title="' + name + '" onclick="' + command + ';';
	if ( isIE && IEVersion < 7 )
		img += 'this.className=\'rteImgDn\';';
	img += 'return false"';
	if ( isIE && IEVersion < 7 )
		img += ' onmouseover="this.className=\'rteImgUp\'" onmouseout="this.className=\'\'"';
	img += ' >';
	return img;
};

function returnRTE( rte ) {
	return my_getelementbyid( rte );
};

function updateRTE( rte ) {
	// Update a specific RTE
	dlgCleanUp(); // Closes Pop-ups
	stripGuidelines( rte ); // Removes Table Guidelines
	if ( isSafari ) {
		try {
			stripSafarijunk( rte );
		}
		catch ( e ) {
		}
	}
	parseRTE( rte );
};

function updateRTEs() {
	// update all RTEs
	for ( var i = 0; i < allRTEs.length; i++ ) {
		updateRTE( allRTEs[ i ] );
	}
};

function getTrace() {
	var res = "";
	var currentFunction = arguments.callee.caller;
	while ( currentFunction ) {
		var fn = currentFunction.toString();
		res += fn + "\n";
		currentFunction = currentFunction.caller;
	}
	return res;
};

function parseRTE( rte ) {
	try {
		// Sync rte.value with iframe
		var oRTE = returnRTE( rte );
		if ( isSafari )
			oRTE.focus();
		setHiddenVal( rte );
	}
	catch ( e ) {
		alert( e.message );
	}
};

function setHiddenVal( rte ) {
	// set hidden form field value for current rte
	var oHdnField = document.getElementById( rte + "_html" );
	var oHdnField2 = document.getElementById( rte + "_text" );
	// convert html output to xhtml (thanks Timothy Bell and Vyacheslav Smolin!)
	if ( oHdnField.value == null ) {
		oHdnField.value = "";
	}
	var sRTE = returnRTE( rte );
	var output = sRTE.innerHTML;
	var re = new RegExp( '([a-z]+=["]{1})http[s]*://' + document.domain + '(.*?["]{1})', "gi" );
	output = output.replace( re, '$1$2' ).replace( /\s/g, ' ' );
	oHdnField.value = output;
	// fix to replace special characters added here:
	// oHdnField.value = replaceSpecialChars(oHdnField.value);
	// if there is no content (other than formatting) set value to nothing
	if ( stripHTML( oHdnField.value.replace( /&nbsp;/g, " " ) ) == "" && oHdnField.value.toLowerCase().search( "<hr" ) == -1
			&& oHdnField.value.toLowerCase().search( "<img" ) == -1 ) {
		oHdnField.value = "";
	}
	oHdnField2.value = getTweakedPlainText( rte );
};

function rteCommand( rte, command, option ) {
	try {
		if ( "Paste" == command && my_pasteCommand() ) {
			// the paste command is used only by dragon macro insertion.
			// we need to intercept the pasting as dregon does not add style
			// classes, so pasted paragraphs won't have blank space between them

			// DEBUG( "rteCommand paste called, handled by my_pasteCommand()" );
			return;
		}
		if ( "undo" == command.toLowerCase() && doUndo && doUndo() ) {
			return;
		}
		// alert( "rteCommand called for " + rte + ", " + command );
		// Fire execCommands apropiratly
		currentRTE = rte;
		// function to perform command
		var oRTE = returnRTE( rte );
		dlgCleanUp();
		if ( focusWithoutScrolling ) {
			focusWithoutScrolling( oRTE );
		}
		else {
			oRTE.focus();
		}
		document.execCommand( command, false, option );
		if ( focusWithoutScrolling ) {
			focusWithoutScrolling( oRTE );
		}
		else {
			oRTE.focus();
		}
	}
	catch ( e ) {
		// alert( e );
		// setTimeout("rteCommand('" + rte + "', '" + command + "', '" + option
		// +
		// "');", 10);
	}
	finally {
		checkButtons();
	}
};

function focusToOnEnter( event, rte ) {
	// alert( "focusToOnEnter " + event );
	if ( event ) {
		var unicode = event.charCode ? event.charCode : event.keyCode;
		if ( unicode && unicode == 13 ) {
			// 13 = enter
			focusTo( rte );
			return;
		}
	}
}

function focusTo( rte ) {
	// alert( "focusTo called for " + rte );
	var oRTE = returnRTE( rte );
	if ( focusWithoutScrolling ) {
		focusWithoutScrolling( oRTE );
	}
	else {
		oRTE.focus();
	}
}

function dlgColorPalette( rte, command ) {
	// function to display or hide color palettes
	// if ( isChrome ) {
	// focusTo( rte );
	// }
	setRange( rte );
	// get dialog position
	var oDialog = document.getElementById( 'cp' + rte );
	var buttonElement = document.getElementById( command + "_" + rte );
	var iLeftPos = buttonElement.offsetLeft + 5;
	var iTopPos = buttonElement.offsetTop + 53;
	oDialog.style.left = iLeftPos + "px";
	oDialog.style.top = iTopPos + "px";
	if ( ( command == parent.command ) && ( rte == currentRTE ) ) {
		// if current command dialog is currently open, close it
		if ( oDialog.style.display == "none" ) {
			showHideElement( oDialog, 'show', false );
		}
		else {
			showHideElement( oDialog, 'hide', false );
		}
	}
	else {
		// if opening a new dialog, close all others
		for ( var i = 0; i < allRTEs.length; i++ ) {
			showHideElement( 'cp' + allRTEs[ i ], 'hide', false );
		}
		showHideElement( oDialog, 'show', false );
	}
	// save current values
	currentRTE = rte;
	parent.command = command;
};

function dlgLaunch( rte, command, width, height ) {
	// Prepair to open a popup

	// save current values
	parent.command = command;
	currentRTE = rte;
	switch ( command ) {
	case "char":
		InsertChar = popUpWin( includesPath + 'insert_char.htm', 'InsertChar', width, height, 'status=yes,' );
		break;
	case "table":
		InsertTable = popUpWin( includesPath + 'insert_table.htm', 'InsertTable', width, height, 'status=yes,' );
		break;
	case "image":
		setRange( rte );
		parseRTE( rte );
		InsertImg = popUpWin( includesPath + 'insert_img.htm', 'AddImage', width, height, 'status=yes,' );
		break;
	case "link":
		selectedText = getSelectedTextRte( rte );
		InsertLink = popUpWin( includesPath + 'insert_link.htm', 'InsertLink', width, height, 'status=yes,' );
		break;
	case "replace":
		selectedText = getSelectedTextRte( rte );
		dlgReplace = popUpWin( includesPath + 'replace.htm', 'dlgReplace', width, height, 'status=yes,' );
		break;
	case "text":
		dlgPasteText = popUpWin( includesPath + 'paste_text.htm', 'dlgPasteText', width, height, 'status=yes,' );
		break;
	case "word":
		dlgPasteWord = popUpWin( includesPath + 'paste_word.htm', 'dlgPasteWord', width, height, 'status=yes,' );
		break;
	}
};

function getSelectedTextRte( rte ) {
	// get currently highlighted text and set link text value
	var oRTE = returnRTE( rte );
	if ( isIE ) {
		setRange( rte );
		var rtn = stripHTML( rng.htmlText );
		parseRTE( rte );
		return rtn.replace( "'", "\'" );
		// rtn = rtn.replace("'","\\\\\\'");
	}
	else
		// This little hack is the only one that works consistantly in Safari
		return oRTE.getSelection() + '';
};

function dlgCleanUp( iframe ) {
	if ( iframe ) {
		if ( !iframe.id ) {
			iframe = my_getelementbyid( iframe );
		}
		if ( iframe ) {
			setFocusedElement( iframe );
			currentRTE = iframe.id;
		}
	}
	// Close any open popup window
	for ( var i = 0; i < allRTEs.length; i++ ) {
		showHideElement( 'cp' + allRTEs[ i ], 'hide', false );
	}
	if ( InsertChar != null ) {
		try {
			InsertChar.close();
			InsertChar = null;
		}
		catch ( e ) {
			InsertChar = null;
		}
	}
	if ( InsertTable != null ) {
		try {
			InsertTable.close();
			InsertTable = null;
		}
		catch ( e ) {
			InsertTable = null;
		}
	}
	if ( InsertLink != null ) {
		try {
			InsertLink.close();
			InsertLink = null;
		}
		catch ( e ) {
			InsertLink = null;
		}
	}
	if ( InsertImg != null ) {
		try {
			InsertImg.close();
			InsertImg = null;
		}
		catch ( e ) {
			InsertImg = null;
		}
	}
	if ( dlgReplace != null ) {
		try {
			dlgReplace.close();
			dlgReplace = null;
		}
		catch ( e ) {
			dlgReplace = null;
		}
	}
	if ( dlgPasteText != null ) {
		try {
			dlgPasteText.close();
			dlgPasteText = null;
		}
		catch ( e ) {
			dlgPasteText = null;
		}
	}
	if ( dlgPasteWord != null ) {
		try {
			dlgPasteWord.close();
			dlgPasteWord = null;
		}
		catch ( e ) {
			dlgPasteWord = null;
		}
	}
};

function popUpWin( url, win, width, height, options ) {
	// Open a popup window
	// TODO this is bloced by popup blockers.
	dlgCleanUp();
	var leftPos = ( screen.availWidth - width ) / 2;
	var topPos = ( screen.availHeight - height ) / 2;
	options += 'width=' + width + ',height=' + height + ',left=' + leftPos + ',top=' + topPos;
	return window.open( url, win, options );
};

function setColor( color ) {
	// function to set color
	var rte = currentRTE;
	var parentCommand = parent.command;
	if ( isIE || isSafari ) {
		if ( parentCommand == "hilitecolor" ) {
			parentCommand = "BackColor";
		}
	}
	// retrieve selected range
	if ( isIE ) {
		// rng.select();
		focusWithoutScrolling( returnRTE( rte ) );
	}
	if ( isGecko )
		rteCommand( rte, "useCSS", false );
	if ( isGecko )
		rteCommand( rte, "styleWithCSS", true );

	rteCommand( rte, parentCommand, color );

	if ( isGecko )
		rteCommand( rte, "useCSS", true );
	if ( isGecko )
		rteCommand( rte, "styleWithCSS", false );
	if ( !( isSafari && SafariVersion < 500 ) )
		showHideElement( 'cp' + rte, "hide", false );
	if ( isIE || isChrome ) {
		window.focus();
		setTimeout( "focusTo( '" + rte + "' )", 10 );
	}
};

function selectFont( rte, selectname, zeroIsLabel ) {
	// alert( "selectfont runs" );
	// function to handle font changes
	var idx = document.getElementById( selectname ).selectedIndex;
	// First one is a label when zeroIsLabel is true
	if ( !zeroIsLabel || idx != 0 ) {
		var selected = document.getElementById( selectname ).options[ idx ].value;
		var cmd = selectname.replace( '_' + rte, '' );
		// alert( "innerHTML before: " + returnRTE( rte ).innerHTML );
		rteCommand( rte, cmd, selected );
		// alert( "innerHTML after: " + returnRTE( rte ).innerHTML );
		if ( zeroIsLabel ) {
			document.getElementById( selectname ).selectedIndex = 0;
		}
	}
};

function insertHTML( html, rte ) {
	// DEBUG( "called pasteHTML("+escape(html)+")" );
	// function to add HTML -- thanks dannyuk1982
	if ( !rte ) {
		rte = currentRTE;
	}
	var oRTE = returnRTE( rte );
	if ( focusWithoutScrolling ) {
		focusWithoutScrolling( oRTE );
	}
	else {
		oRTE.focus();
	}
	if ( isIE ) {
		var oRng = document.selection.createRange();
		// pasteHTML seems to transform \n into <br> which is highly
		// undesirable, so we get rid of \n characters just in case...
		html = html.replace( /\n/g, "" );
		oRng.pasteHTML( html );
		oRng.collapse( false );
		oRng.select();
	}
	else {
		document.execCommand( 'InsertHTML', false, html );
	}
	checkSize();
};

function my_pasteCommand() {
	DEBUG( "my_pasteCommand() called" );
	if ( !isIE ) {
		return false;
	}
	if ( window.getSelection ) {
		// ie11 way...
		oRTE = returnRTE( currentRTE );
		// before pasting: mark non-marked paragraphs as erad
		$( oRTE ).find( "p:not('.pasted')" ).not( '.erad' ).each( function() {
			var newClass = "erad";
			if ( $( this ).attr( "class" ) ) {
				newClass += " " + $( this ).attr( "class" );
			}
			$( this ).attr( "class", newClass );
		} );

		document.execCommand( "Paste" );

		// after pasting: mark non-marked paragraphs as pasted
		$( oRTE ).find( "p:not('.pasted')" ).not( '.erad' ).each( function() {
			var newClass = "pasted";
			if ( $( this ).attr( "class" ) ) {
				newClass += " " + $( this ).attr( "class" );
			}
			$( this ).attr( "class", newClass );
		} );

		return true;
	}
	var range = document.selection.createRange();
	try {
		var tmpDiv = document.getElementById( "tmpPasteDiv" );

		if ( !tmpDiv ) {
			tmpDiv = document.createElement( "DIV" );
			tmpDiv.id = "tmpPasteDiv";
			tmpDiv.style.position = "absolute";
			$( tmpDiv ).offset( {
				top : $( "body" ).scrollTop(),
				left : $( "body" ).scrollLeft() - 1000
			} );
			tmpDiv.style.zIndex = "-1";
			tmpDiv.contentEditable = true;
			document.body.appendChild( tmpDiv );
		}
		// range.moveToElementText( tmpDiv );
		var x = getScrollPositionX();
		var y = getScrollPositionY();
		tmpDiv.focus();
		document.execCommand( "Paste" );
		range.select();
		setScrollPosition( x, y );
	}
	catch ( e ) {
		// alert( "Sorry, your browser does not support this feature. Please
		// right click the highlighted text and select 'copy'." + dumpObj( e,
		// true ) );
		range.select();
		return false;
	}
	DEBUG( "my_pasteCommand(): pasted innerHTML is " + tmpDiv.innerHTML );
	$( tmpDiv ).find( "p:not('.pasted')" ).not( '.erad' ).each( function() {
		// add "pasted" class as first (lowest priority) class
		var newClass = "pasted";
		if ( $( this ).attr( "class" ) ) {
			newClass += " " + $( this ).attr( "class" );
		}
		$( this ).attr( "class", newClass );
	} );
	var html = tmpDiv.innerHTML;
	tmpDiv.innerHTML = "";
	insertHTML( html );
	return true;
};

function SearchAndReplace( searchFor, replaceWith, matchCase, wholeWord ) {
	// TODO in IE question appears below the popup, so move the question to the
	// popup and colose the popup from here when that has been answered
	var cfrmMsg = lblSearchConfirm.replace( "SF", searchFor ).replace( "RW", replaceWith );
	var rte = currentRTE;
	stripGuidelines( rte );
	if ( isSafari )
		stripSafarijunk( rte );
	var oRTE = returnRTE( rte );
	var tmpContent = oRTE.innerHTML.replace( "'", "\'" ).replace( '"', '\"' );
	var strRegex;
	if ( matchCase && wholeWord ) {
		strRegex = "/(?!<[^>]*)(\\b(" + searchFor + ")\\b)(?![^<]*>)/g";
	}
	else if ( matchCase ) {
		strRegex = "/(?!<[^>]*)(" + searchFor + ")(?![^<]*>)/g";
	}
	else if ( wholeWord ) {
		strRegex = "/(?!<[^>]*)(\\b(" + searchFor + ")\\b)(?![^<]*>)/gi";
	}
	else {
		strRegex = "/(?!<[^>]*)(" + searchFor + ")(?![^<]*>)/gi";
	}
	var cmpRegex = eval( strRegex );
	var runCount = 0;
	var tmpNext = tmpContent;
	var intFound = tmpNext.search( cmpRegex );
	while ( intFound > -1 ) {
		runCount = runCount + 1;
		tmpNext = tmpNext.substr( intFound + searchFor.length );
		intFound = tmpNext.search( cmpRegex );
	}
	if ( runCount > 0 ) {
		cfrmMsg = cfrmMsg.replace( "[RUNCOUNT]", runCount );
		if ( confirm( cfrmMsg ) ) {
			tmpContent = tmpContent.replace( cmpRegex, replaceWith );
			oRTE.innerHTML = tmpContent.replace( "\'", "'" ).replace( '\"', '"' );
		}
		else {
			alert( lblSearchAbort );
		}
		showGuidelines( rte );
		// needed for editing some attributes
		if ( isSafari )
			applySafarijunk( rte );
	}
	else {
		showGuidelines( rte );
		// needed for editing some attributes
		if ( isSafari )
			applySafarijunk( rte );
		alert( "[" + searchFor + "] " + lblSearchNotFound );
	}
};

function showHideElement( element, showHide, rePosition ) {
	// function to show or hide elements
	// element variable can be string or object
	if ( document.getElementById( element ) ) {
		element = document.getElementById( element );
	}
	if ( showHide == "show" ) {
		element.style.display = "";
		if ( rePosition ) {
			element.style.position = "relative";
			element.style.left = "auto";
			element.style.top = "auto";
		}
	}
	else if ( showHide == "hide" ) {
		element.style.display = "none";
	}
};

function setRange( rte ) {
	// function to store range of current selection
	var selection;
	if ( isIE ) {
		selection = document.selection;
		if ( selection != null ) {
			rng = selection.createRange().duplicate();
		}
	}
	else {
		selection = window.getSelection();
		/*
		 * //TODO Safari 1.3 dosn't support getRangeAt()
		 * http://www.quirksmode.org/dom/range_intro.html if(isSafari) { var rng =
		 * selection.createRange();
		 * rng.setStart(selection.anchorNode,selection.anchorOffset);
		 * rng.setEnd(selection.focusNode,selection.focusOffset); } else {
		 */
		// This solves a strange issue in Safari 3 where the folowing command
		// stops
		// the script after an unslect has been fired - Anders Jenbo
		if ( selection.rangeCount == 0 && isSafari && safariDummyRange != null ) {
			rng = safariDummyRange;
		}
		else {
			if ( isSafari && safariDummyRange == null ) {
				safariDummyRange = document.createRange();
				safariDummyRange.setStart( document.body, 0 );
				safariDummyRange.setEnd( document.body, 0 );
			}
			if ( !( isSafari && SafariVersion < 500 ) )
				rng = selection.getRangeAt( 0 ).cloneRange();
			else {
				rng = safariDummyRange;
				/*
				 * rng = selection.createRange();
				 * rng.setStart(selection.anchorNode,selection.anchorOffset);
				 * rng.setEnd(selection.focusNode,selection.focusOffset);
				 */
			}
		}
		// }
	}
	return rng;
};

function stripHTML( strU ) {
	// strip all html
	var strN = strU.replace( /(<([^>]+)>)/ig, "" );
	// replace carriage returns and line feeds
	strN = strN.replace( /\r\n/g, " " );
	strN = strN.replace( /\n/g, " " );
	strN = strN.replace( /\r/g, " " );
	strN = trim( strN );
	return strN;
};

function trim( inputString ) {
	// Remove white space at the start and end of a string
	if ( typeof inputString != "string" ) {
		return inputString;
	}
	inputString = inputString.replace( /^\s+|\s+$/g, "" ).replace( /\s{2,}/g, "" );
	return inputString;
};

function showGuidelines( rte ) {
	// Add guide lines to tabels with no margin
	// TODO the inner lines are not always visible in Safari
	if ( rte.length == 0 )
		rte = currentRTE;
	var oRTE = returnRTE( rte );
	var tables = oRTE.getElementsByTagName( "table" );
	var sty = "dashed 1px " + zeroBorder;
	for ( var i = 0; i < tables.length; i++ ) {
		if ( tables[ i ].getAttribute( "border" ) == 0 ) {
			if ( isIE || isOpera ) {
				var trs = tables[ i ].getElementsByTagName( "tr" );
				for ( var j = 0; j < trs.length; j++ ) {
					var tds = trs[ j ].getElementsByTagName( "td" );
					for ( var k = 0; k < tds.length; k++ ) {
						if ( j == 0 && k == 0 ) {
							tds[ k ].style.border = sty;
						}
						else if ( j == 0 && k != 0 ) {
							tds[ k ].style.borderBottom = sty;
							tds[ k ].style.borderTop = sty;
							tds[ k ].style.borderRight = sty;
						}
						else if ( j != 0 && k == 0 ) {
							tds[ k ].style.borderBottom = sty;
							tds[ k ].style.borderLeft = sty;
							tds[ k ].style.borderRight = sty;
						}
						else if ( j != 0 && k != 0 ) {
							tds[ k ].style.borderBottom = sty;
							tds[ k ].style.borderRight = sty;
						}
					}
				}
			}
			else {
				tables[ i ].removeAttribute( "border" );
				tables[ i ].setAttribute( "style", "border: " + sty );
				tables[ i ].setAttribute( "rules", "all" );
			}
		}
	}
};

function stripGuidelines( rte ) {
	// strip any guide lines from tabels befor outputtin the source.
	var oRTE = returnRTE( rte );
	var tbls = oRTE.getElementsByTagName( "table" );
	for ( var j = 0; j < tbls.length; j++ ) {
		if ( tbls[ j ].getAttribute( "border" ) == 0 || tbls[ j ].getAttribute( "border" ) == null ) {
			if ( isIE || isOpera ) {
				var tds = tbls[ j ].getElementsByTagName( "td" );
				for ( var k = 0; k < tds.length; k++ ) {
					tds[ k ].removeAttribute( "style" );
				}
			}
			else {
				tbls[ j ].removeAttribute( "style" );
				tbls[ j ].removeAttribute( "rules" );
				tbls[ j ].setAttribute( "border", "0" );
			}
		}
	}
};

function applySafarijunk( rte ) {
	// Theas are needed in safari for it to behave correctly
	if ( rte.length == 0 )
		rte = currentRTE;
	var oRTE = returnRTE( rte );
	var blockquotes = oRTE.document.getElementsByTagName( "blockquote" );
	for ( var i = 0; i < blockquotes.length; i++ ) {
		if ( !blockquotes[ i ].getAttribute( "Class" ) ) {
			blockquotes[ i ].setAttribute( "Class", "webkit-indent-blockquote" );
		}
	}
};

function stripSafarijunk( rte ) {
	// Safari generates some internal classes and dosn't clean it up
	var oRTE = returnRTE( rte );
	var brbls = oRTE.document.getElementsByTagName( "br" );
	for ( var j = 0; j < brbls.length; j++ ) {
		brbls[ j ].removeAttribute( "Class" );
	}
	var spanbls = oRTE.document.getElementsByTagName( "span" );
	for ( var j = 0; j < spanbls.length; j++ ) {
		if ( spanbls[ j ].getAttribute( "Class" ) == 'Apple-style-span' ) {
			spanbls[ j ].removeAttribute( "Class" );
		}
	}
	var fontbls = oRTE.document.getElementsByTagName( "font" );
	for ( var j = 0; j < fontbls.length; j++ ) {
		if ( fontbls[ j ].getAttribute( "Class" ) == 'Apple-style-span' ) {
			fontbls[ j ].removeAttribute( "Class" );
		}
	}
	var blockquotebls = oRTE.document.getElementsByTagName( "blockquote" );
	for ( var j = 0; j < blockquotebls.length; j++ ) {
		if ( blockquotebls[ j ].getAttribute( "Class" ) == 'webkit-indent-blockquote' ) {
			blockquotebls[ j ].removeAttribute( "Class" );
		}
	}
};

function replaceIt( string, text, by ) {
	// CM 19/10/04 custom replace function
	var strLength = string.length, _xtLength = text.length;
	if ( ( strLength == 0 ) || ( _xtLength == 0 ) ) {
		return string;
	}
	var i = string.indexOf( text );
	if ( ( !i ) && ( text != string.substring( 0, _xtLength ) ) ) {
		return string;
	}
	if ( i == -1 ) {
		return string;
	}
	var newstr = string.substring( 0, i ) + by;
	if ( i + _xtLength < strLength ) {
		newstr += replaceIt( string.substring( i + _xtLength, strLength ), text, by );
	}
	return newstr;
};

var hsvMap = {};

function getHSV( rte ) {
	if ( !hsvMap[ rte ] ) {
		hsvMap[ rte ] = new HoverSourceView( rte );
	}
	return hsvMap[ rte ];
};

function showRteSource( rte ) {
	getHSV( rte ).show();
};

// this function requires LayoutScripts.js
function HoverSourceView( rte ) {
	if ( typeof DraggableHoverDiv == "undefined" ) {
		alert( "The sourceview function of the richtext editor requires LayoutScripts.js" );
		return;
	}
	this.rte = rte;

	// create the hover
	this.hover = new DraggableHoverDiv( true );
	// add buttons
	// this.hover.hoverDiv.appendChild( document.createElement( "br" ) );
	var buttonsDiv = document.createElement( "div" );
	buttonsDiv.align = "right";
	// buttonsDiv.style.float = "right";
	buttonsDiv.style.marginLeft = "auto";
	buttonsDiv.style.marginRight = "0px";
	buttonsDiv.style.right = "0px";
	buttonsDiv.style.whiteSpace = "nowrap";
	this.hover.hoverDiv.appendChild( buttonsDiv );
	var okButton = createDynamicButton( "BUTTON_APPLY" );
	eval( "addEventListenerTo( okButton, 'click', function() {	getHSV( '" + rte + "' ).apply(); } )" );
	buttonsDiv.appendChild( okButton );
	var cancelButton = createDynamicButton( "BUTTON_CLOSE" );
	cancelButton.style.marginRight = "10px";
	eval( "addEventListenerTo( cancelButton, 'click', function() {	getHSV( '" + rte + "' ).hover.hide(); } )" );
	buttonsDiv.appendChild( cancelButton );
	this.textarea = document.createElement( "textarea" );
	this.textarea.cols = 80;
	this.textarea.rows = 15;
	this.hover.contentDiv.appendChild( this.textarea );

	this.show = function() {
		var rteDiv = returnRTE( this.rte );
		this.textarea.value = rteDiv.innerHTML;
		this.hover.position( calcElementLeft( rteDiv ), calcElementTop( rteDiv ) + rteDiv.clientHeight );
		this.hover.show();
	};

	this.apply = function() {
		returnRTE( this.rte ).innerHTML = this.textarea.value;
	};
};

// called from Fluency - after cursor moves we set the buttons'
function processCursorMove() {
	checkAll( false, currentRTE );
}
