#!/bin/sh
#
# Component: cases
#
# Description:
#   OBSOLETE [7.0]: use cases.SetStudyAttribute java task instead
#
#   Sets/synchronize study attributes on dotcom device
#   Study attributes to be synchronized are:
#       Retrieved
#       DontEdit
#       SourceDevice
#       ArchiveDevice
#
# Options:
#   -H hostID : ID of the peer dotcom device
#   -s study  : Study Instance UID of the study
#   -f        : Force re-synchronizing study attributes
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh


# if setStudyAttributes.sh is called directly:
# run as a task instead
if [ `basename $0` = "setStudyAttribute.sh" ] ; then
	$TASKD_HOME/runshellcmd.sh -R -r 0 $0 "$@"
	exit $?
fi

LOGGER="/usr/bin/logger"
TAG="setStudyAttributes[$$]"


# include nettask.shi for checking if the device is temporary down
. $TASKD_HOME/nettask.shi


INPUT_PARAMS=""
Study=""
HostID=""
ERRMSG=""

while getopts 'fH:s:' OPT; do
	case $OPT in
		H) HostID="$OPTARG"; INPUT_PARAMS="$INPUT_PARAMS -H \"$OPTARG\"" ;;
		s) Study="$OPTARG"; INPUT_PARAMS="$INPUT_PARAMS -s \"$OPTARG\"" ;;
		f) INPUT_PARAMS="$INPUT_PARAMS -f" ;;
		*) ERRMSG="Invalid_Parameter:$OPT" ;;
	esac
done


# override getPeer_() of nettask.shi
getPeer_()
{
	echo "$HostID"
}


# override run_ method
run_()
{
	$TASKD_HOME/runjavacmd -c "0 cases.SetStudyAttribute $INPUT_PARAMS" -p "$JAVA_SERVER_PORT"
	ERR=$?

	exit $ERR
}


# override cleanup_
cleanup_()
{
	$TASKD_HOME/runjavacmd -c "cleanup cases.SetStudyAttribute $INPUT_PARAMS" -p "$JAVA_SERVER_PORT"
}


# override print_
print_()
{
	$TASKD_HOME/runjavacmd -c "print cases.SetStudyAttribute $INPUT_PARAMS" -p "$JAVA_SERVER_PORT"
}
