#!/bin/sh
. ~/etc/setenv.sh

file=$1;
shift;

function checkMatching_() {
    origDir=`pwd`
    checkedFile=""
    for ddir in `echo $1 |awk -vRS="/" '{print $0}'` ; do
	found="false"
        for dir in `ls | grep -i "^$ddir$"` ; do
	    [ "$checkedFile" != "" ] && checkedFile="${checkedFile}/"
	    checkedFile="${checkedFile}${dir}"
	    [ -d $dir ] && cd $dir
	    found="true"
	    break;
	done
	if [ "$found" = "false" ] ; then
	    break; # failed
	fi
    done
    cd $origDir
}


dir=`dirname $file`;

vpar=`echo $@ | sed -e "s; ;|;g;"`

result=`$DCVIEWER_HOME/herelo -d $file | awk -vdir=$dir -vpar=$vpar '
function checkPbrs() {
  if (objnam ~ "^S[0-9][0-9]O[0-9][0-9][0-9][0-9]")
  {
    pnam= substr(objnam,1,3) "P";
    snam= substr(objnam,1,3) "S";
    cmd = "cd " dir "; ls " pnam "* " snam "* 2>/dev/null";
    while ((cmd | getline v) > 0){
      print v;
    }
  }
}
BEGIN {
	pp="|" par "|";
	bprint=0;
	objnam="";
	study="unknown";
}


$1=="(0020,000d)" {
	if ( par=="" || index(pp,"|" $3 "|")!=0)
		bprint=1;
	else
		bprint=0;
	checkPbrs();
	study=$3;
}

$1=="(0004,1500)" {
	if (bprint) {
		objnam=$3;
		gsub("\\\\\\\\","/",objnam);
		if( index( objnam, "/" ) == 1 ) { 
			print study objnam;
		}
		else { 
			print study "/" objnam;
		}
	}
}

END {
	checkPbrs();
}
' | sed "s;^/;;"`


#checking result, adjusting filenames like if we were case insensitive if needed
newResult=""
for ff in $result ; do
	study=$(cut -f 1 -d "/" <<<"$ff")
	file=$(cut -f 2- -d "/" <<<"$ff")

    if [ ! -f $file ] ; then
		file=`echo "$file" | awk '{print tolower($0)}'`
    fi
    if [ ! -f $file ] ; then
		file=`echo "$file" | awk '{print toupper($0)}'`
    fi
    if [ ! -f $file ] ; then
		checkMatching_ $file
		checkedUpper=`echo "$checkedFile" | awk '{print toupper($0)}'`
		if [ "$file" = "$checkedUpper" ] ; then
	    	file=$checkedFile
		fi
    fi
    if [ -f $file ] ; then
		[ "$newResult" != "" ] && newResult="${newResult} "
		newResult="${newResult}${file}"
	else
		echo "OBJECT NOT FOUND	${file}	${study}" >&2
    fi
done
echo "${newResult}"