<%--
 * Component: cd
 *
 * Description:
 *   Returns progress information for a DICOM media creation session
 *
 * Last Updated     : $Author: tnemeth $
 * Update Date Time : $Date: 2014/01/24 10:35:14 $
 * RCS File Name    : $RCSfile: progressInfo.jsp,v $
 * RCS Revision     : $Revision: 1.2 $
 * Locked by        : $Locker:  $
 * Symbolic name    : $Name:  $
 * State            : $State: Exp $
 *
--%><%@
	page import="
		java.util.*,
		imagemed.dicom.*,
		imagemed.util.*"

%><%

	String id = request.getParameter( "cID" );

	Map<String, Object> res = new HashMap<String, Object>();

	try {
		DicomMediaSession dms = new DicomMediaSession( id );
	
		if ( dms.isCompleted() ) {
			res.put( "isComplete", true );
			DicomMediaSession.Result result = dms.getResult();
			res.put( "isResultOK", result.isOK() );
			res.put( "errorMessage", result.getErrorMessage() );
		}
		else {
			res.put( "isComplete", false );
			try {
				DicomMediaSession.ProgressInfo progressInfo = dms.calcProgress();
				double createPercent = progressInfo.getCreatePercent();
				if ( 0 < createPercent && createPercent < 1 ) {
					// Set to 1 to force displaying the progress bar
					createPercent = 1.00;
				}
				res.put( "progressCollect", (int) progressInfo.getConvertPercent() );
				res.put( "progressCreate", (int) createPercent );
				Helper.DEBUG( "In progress " + progressInfo.getConvertPercent() + "/" + progressInfo.getCreatePercent() );
			}
			catch ( Throwable th ) {
				Helper.DEBUG( Helper.throwable2String( th ) );
			}
		}
		
		out.print( JSHelper.toJSON( res ) );
	}
	finally {
		Helper.DEBUG( "RES: " + Helper.toString( res ) );
	}
	
	if ( true ) {
		return;
	}
%>