package imagemed.layout.validator;

import java.sql.*;
import java.util.Calendar;

import com.erad.pacs.services.usermanager.client.Session;

import imagemed.imsession.*;
import imagemed.layout.LayoutPart;
import imagemed.types.IMType;
import imagemed.types.date.TimeStamp;
import imagemed.util.*;



public class DefaultpacsStudyEditValidator extends DcmEntryValidator {

	private boolean cOrder;


	public DefaultpacsStudyEditValidator( boolean cOrder ) {
		this.cOrder = cOrder;
	}

	@Override
	protected void preValidate( Session session ) {
		boolean isCreateOrder = cOrder;

		/*		if ( LayoutPart.ORDERLAYOUT.equals( m_layoutRoot.getFullLayoutType() ) ) {
					setMandatoryError( "PANM" );
					setMandatoryError( "MODA" );
					setMandatoryError( "PSEX" );
					setMandatoryError( "ACCN" );

					if ( isCreateOrder ) {
						//set scheduled date to actual - only if not set, only at create
						String schd = getValue( "SCHD" );
						if ( schd == null || "".equals( schd ) ) {
							schd = Helper.calcDayTimeStr( new GregorianCalendar() );
							setValue( "SCHD", schd );
						}
					}

				}*/
	}

	@Override
	public void validate( Session session ) {
		boolean isCreateOrder = cOrder;

		// check status setting backwards 
		String stateStr = getValue( "STAT" );
		String oldStateStr = m_entry.getRootRecord().getOldValue( "STAT", null );
		if ( oldStateStr != null ) {
			try {
				int state = Integer.parseInt( stateStr );
				int oldState = Integer.parseInt( oldStateStr );
				if ( state < oldState ) {
					m_warnings.add( LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_EDIT_STATUS_BACKWARDS" ) );
				}
			}
			catch ( Throwable th ) {
			}
		}

		// check duplicate Orders - very special, only for Orders
		// duplicate: the same patient name, also an order, date is within 1 min
		if ( isCreateOrder && LayoutPart.ORDERLAYOUT.equals( m_layoutRoot.getFullLayoutType() ) ) {
			String newCanonicPN = IMType.getTypeFor( "PN" ).canonize( getValue( "PANM" ) );
			String schedTime = getValue( "SCHD" );
			TimeStamp tsThis = new TimeStamp( schedTime );
			Calendar calThis = tsThis.getCalendar();

			try {
				Connection IMDB = IMEnv.getDB();
				java.sql.Statement st = IMDB.createStatement();
				String strSt = "SELECT THEDATETIME,PNAME from " + IMEnvBase.getEnv( "STUDYTBL" ) + " WHERE MAINST<0";
				ResultSet rs = st.executeQuery( strSt );
				while ( rs.next() ) {
					String canonicPN = IMType.getTypeFor( "PN" ).canonize( rs.getString( "PNAME" ) );
					String dateTimeM = rs.getString( "THEDATETIME" );
					TimeStamp tsOther = new TimeStamp( dateTimeM );
					Calendar calOther = tsOther.getCalendar();
					if ( newCanonicPN.equals( canonicPN ) ) {
						long diff = Math.abs( calThis.getTimeInMillis() - calOther.getTimeInMillis() );
						if ( diff <= 60000 ) { //1 min
							m_warnings.add( LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_EDIT_DUPLICATE_ORDER" ) );
							break;
						}
					}
				}
			}
			catch ( SQLException e ) {
				Helper.defaultCatch( e );
			}
		}

	}

}
